\ *** LOCK O. 12, EXBLOCK C

\ CODEGEN LOADSCREEN           21SEP94PZ

\ *** LOCK O. 13, EXBLOCK D

\ CODEGEN: OBJECTS             13JAN91PZ

\ AN OBJECT IS 8 OR 16 BIT NUMERICAL
\ VALUE ON THE RUNTIME-STACK.
\ AT COMPILE TIME IT IS REPRESENTED BY
\ A 16 BIT DESCIPTOR AND A 16 BIT
\ VALUE  ( OBJ ) = ( VAL DESC ).

\ THE DESCRIPTOR CONSTISTS OF DATA TYPE

ON

1 CONSTANT %INT

\ AND OBJECT TYPE

 $100 CONSTANT %L-VALUE   \ PROVIDED
 $200 CONSTANT %POINTER   \ BY THE
 $400 CONSTANT %FUNCTION  \ SYMBOL
 $800 CONSTANT %OFFSET    \ TABLE
$1000 CONSTANT %FASTCALL   \
$2000 CONSTANT %EXTERN    \
$4000 CONSTANT %PROTO

$8000 CONSTANT %CONSTANT  \ GENERATED
\ INTERNALLY FOR OPTIMIZATION.


\ *** LOCK O. 14, EXBLOCK E

\   CODEGEN: OBJECTS           26SEP90PZ

\  HANDLE DATA TYPE
: SET-CHAR     %INT NOT AND ;
: SET-INT      %INT OR ;
     ( N1 -- N2 )

: IS-CHAR?     DUP %INT AND 0= ;
: IS-INT?      IS-CHAR? 0= ;
     ( N -- N FLAG )

\  HANDLE OBJECT TYPE
: SET          OR ;
: CLR          NOT AND ;
     ( N1 MASK -- N2 )

: IS?          2DUP XOR AND 0= ;
: ISN'T?       OVER AND 0= ;
     ( N MASK -- N FLAG )
     \ FLAG = TRUE <=> ALLE GESETZTEN
     \ MASK-BITS IN N GESETZT BZW.
     \ GELOESCHT


\ *** LOCK O. 15, EXBLOCK F

\   CODEGEN: OBJECTS           11MAR91PZ

: SIZE? ( OBJ -- OBJ SIZE )
     %POINTER %FUNCTION + ISN'T? >R
     IS-CHAR? R> AND 2+ ;

\ SIZE? UND .SIZE MACHEN NUR BEI
\ %L-VALUE-OBJEKTEN SINN !


0 SET-INT  CONSTANT %DEFAULT
  \ DEFAULT DATA TYPE, E.G TYPE OF
  \ A MULTIPICATION'S RESULT

  0 SET-INT %L-VALUE %EXTERN + SET
CONSTANT %GLOBAL
  0 SET-INT %L-VALUE %OFFSET + SET
CONSTANT %LOCAL
  ( DEFAULT DEFINITION TYPES )

$0701 CONSTANT %COND.MASK
$9F01 CONSTANT %EXPR.MASK
$3F01 CONSTANT %DECL.MASK
  ( MASKS FOR TYPE COMPARISONS )


\ *** LOCK O. 16, EXBLOCK 10

\ CODEGEN: NEED-L-VALUE/VALUE     26SEP90PZ

DEFER 'VALUE      ( OBJ1 -- OBJ2 )

: VALUE ( OBJ1 -- OBJ2 )
   %L-VALUE IS?
       'VALUE  %L-VALUE CLR
      %FUNCTION %POINTER + ISN'T?
          SET-INT   ;

: NEED-L-VALUE ( OBJ1 -- OBJ2 )
   %L-VALUE IS?
       %L-VALUE CLR
       *NOLVAL* ERROR  ;


\ *** LOCK O. 17, EXBLOCK 11

\ CODEGEN: CONSTANT, DOIT      18APR94PZ

VARIABLE A-USED

: REQUIRE-ACCU
     A-USED @  .PHA' 
     A-USED ON ;

: RELEASE-ACCU
     A-USED OFF ;

: NON-CONSTANT ( OBJ1 -- OBJ2 )
     %CONSTANT IS?   %CONSTANT CLR
       REQUIRE-ACCU  SIZE? .SIZE OVER .LDA#.S  ;

   INIT: RELEASE-ACCU


VARIABLE VECTOR

: DOIT ( N -- )
     VECTOR @ + PERFORM ;
  \ FOR UNOP, INCOP AND DO-BINOP, WHO
  \ ALL USE VECTORS


\ *** LOCK O. 18, EXBLOCK 12

\ CODEGEN: COMBINED TYPE TESTS 01MAR91PZ

: POINTER? ( TYPE -- TYPE FLAG )
     %POINTER IS? >R %FUNCTION ISN'T?
     R> AND ;
  ( FOR DO-ADD AND DO-SUB )

: INT-POINTER? ( TYPE -- TYPE FLAG )
     POINTER? >R IS-INT? R> AND ;
  ( FOR INCOP )
  ( BOTH FOR POINTER SCALING )

: ARRAY? ( TYPE -- TYPE FLAG )
     %L-VALUE %FUNCTION + ISN'T? >R
     %POINTER IS? R> AND ;
  ( FOR DEFINITIONS )

: FUNCTION? ( TYPE -- TYPE FLAG )
     %FUNCTION IS? >R %L-VALUE ISN'T?
     R> AND ;
  ( FOR PREPARE-CALL AND DEFINITIONS )


\ *** LOCK O. 19, EXBLOCK 13

\ CODEGEN: ATOM                18APR94PZ

: DO-NUMATOM ( VAL -- OBJ )
     [ %DEFAULT  %CONSTANT SET ]
     LITERAL ;

\ : HIS COULD PROBABLY RETURN A %CONST VALUE; THE ADDRESS OF THE
\ STRING IS, AFTER ALL, ESSENTIALLY KNOWN AT COMPILE TIME.

: DO-STRINGATOM ( ADR -- OBJ )
     REQUIRE-ACCU  .LDA#
     [ %DEFAULT %POINTER SET SET-CHAR ]
     0  LITERAL ;


: DO-LDA(A) ( OBJ1 -- OBJ2 )
     SIZE? .SIZE
     %CONSTANT IS?
           REQUIRE-ACCU
        OVER .LDA.S  %CONSTANT CLR
         .STA-ZP .LDA.S(ZP)  ;


\ *** LOCK O. 20, EXBLOCK 14

\   CODEGEN: ATOM              27MAY91PZ

: DO-LDA(BASE),# ( OBJ1 -- OBJ2 )
     %OFFSET ISN'T? *COMPILER* ?FATAL
     REQUIRE-ACCU  SIZE? .SIZE
     OVER .LDA.S(BASE),#
     %OFFSET CLR ;

: DO-IDATOM ( NAME -- OBJ )
     DUP FINDLOCAL ?DUP
         NIP
         FINDGLOBAL ?DUP 0=
            *UNDEF* ERROR
           0 DO-NUMATOM EXIT 
         2@
     %EXPR.MASK AND
     %OFFSET ISN'T?
         ['] DO-LDA(A)   'VALUE
        %CONSTANT SET  EXIT 
     %L-VALUE IS?
         ['] DO-LDA(BASE),#  'VALUE
         REQUIRE-ACCU  .LDA-BASE
        OVER .ADD#  %OFFSET CLR  ;


\ *** LOCK O. 21, EXBLOCK 15

\ CODEGEN: PRIMARY             22AUG94PZ

VARIABLE #PTR-FASTCALLS
: INIT-FASTCALLS  #PTR-FASTCALLS OFF ;
     INIT: INIT-FASTCALLS

: PREPARE-FAST-CALL ( OBJ1 -- OBJ2 )
     %CONSTANT ISN'T?
      #PTR-FASTCALLS @
        .PHA'  2 .SIZE STATICS.LAST @ 2- .STA.S 
     RELEASE-ACCU
     1 #PTR-FASTCALLS +!  ;

: PUT-FAST-ARGUMENT ( OBJ -- )
     VALUE NON-CONSTANT 2DROP ;

: DO-FAST-CALL ( OBJ1 -- OBJ2 )
     %CONSTANT IS?  OVER .JSR 
     -1 #PTR-FASTCALLS +!
     #PTR-FASTCALLS @
        .JSR(STACK)  .JSR(LASTSTATIC) 
      ;


\ *** LOCK O. 22, EXBLOCK 16

\   CODEGEN: PRIMARY           27MAY91PZ

: PREPARE-CALL ( OBJ1 -- OBJ2 #ARGS )
     VALUE 0 ;

: PUT-ARGUMENT  ( #ARGS OBJ -- #ARGS' )
     VALUE  NON-CONSTANT  2DROP
     2 .SIZE
     2 DYN-ALLOT .STA.S(BASE),#
     RELEASE-ACCU  2- ;


\ *** LOCK O. 23, EXBLOCK 17

\   CODEGEN: PRIMARY           27MAY91PZ

: DO-CALL ( OBJ2 #ARGS -- OBJ3 )
     DYN-ALLOT DYN-OFFS - 2/ >R
     %CONSTANT IS?
      REQUIRE-ACCU  .STA-ZP 
     DYN-OFFS .LINK#
     R> .ARGS
     %CONSTANT IS?
         OVER .JSR
         .JSR(ZP) 
     DYN-OFFS NEGATE .LINK# ;


\ *** LOCK O. 24, EXBLOCK 18

\   CODEGEN: PRIMARY           23FEB91PZ

: DO-POINTER ( OBJ1 -- OBJ2 )
   %L-VALUE IS? >R  VALUE
   %FUNCTION IS?
       R>
          %L-VALUE CLR
          DROP %DEFAULT
         *NOFCTNPTR* ERROR 
       RDROP  %POINTER ISN'T?
         *NOPTR* ?ERROR
      %POINTER CLR  %L-VALUE SET
      ['] DO-LDA(A)  'VALUE
       ;


\ *** LOCK O. 25, EXBLOCK 19

\ CODEGEN: UNARY               27MAY91PZ

: DO-ADRESS ( OBJ1 -- OBJ2 )
   NEED-L-VALUE
   %OFFSET IS?
       REQUIRE-ACCU
      .LDA-BASE  OVER .ADD#
      %OFFSET CLR 
   SIZE? 1-  SET-INT 
   %POINTER SET  %FUNCTION CLR ;


: UNOP ( CFA2 CFA0 -- )
     CREATE , ,
    DOES> ( OBJ1 PFA -- OBJ2 ) VECTOR !
     VALUE  %CONSTANT IS? NIP
         2 DOIT
        %DEFAULT  %CONSTANT SET
         0 DOIT %DEFAULT  ;

' NEGATE  ' .NEG  UNOP DO-NEG
' 0=      ' .NOT  UNOP DO-NOT
' NOT     ' .INV  UNOP DO-INV


\ *** LOCK O. 26, EXBLOCK 1A

\   CODEGEN: UNARY             18APR94PZ

: INCOP ( CFA6 CFA4 CFA2 CFA0 -- )
     CREATE , , , ,
    DOES> ( OBJ1 PFA -- OBJ2 ) VECTOR !
     NEED-L-VALUE  SIZE? .SIZE
     %CONSTANT IS?
         %CONSTANT CLR  REQUIRE-ACCU
        INT-POINTER? 2 AND DOIT
      %OFFSET IS?
         %OFFSET CLR  REQUIRE-ACCU
        INT-POINTER? 1 AND 1+
        2 PICK  DUP .LDA.S(BASE),#
        SWAP  6 DOIT
      .STA-ZP  .LDA.S(ZP)
        INT-POINTER? 1 AND 1+  4 DOIT
      
     %FUNCTION IS?
         DROP %DEFAULT  ;

\ THE COMPLICATIONS ARE DUE TO THE
\ DIFFERENT ADRESSING MODES AND TO
\ THE SCALING OF POINTERS.


\ *** LOCK O. 27, EXBLOCK 1B

\   CODEGEN: UNARY             27MAY91PZ

: ++X0 OVER DUP .INCR.S   .LDA.S ;
: ++X2 OVER DUP .2INCR.S  .LDA.S ;
: ++X4 .ADD#  .STA.S(ZP) ;
: ++X6 .ADD#  .STA.S(BASE),# ;

: --X0 OVER DUP .DECR.S   .LDA.S ;
: --X2 OVER DUP .2DECR.S  .LDA.S ;
: --X4 .SUB#  .STA.S(ZP) ;
: --X6 .SUB#  .STA.S(BASE),# ;

: X++0 OVER DUP .LDA.S  .INCR.S ;
: X++2 OVER DUP .LDA.S  .2INCR.S ;
: X++4 .PHA .ADD#  .STA.S(ZP) .PLA ;
: X++6 .PHA .ADD#  .STA.S(BASE),#
                                .PLA ;

: X--0 OVER DUP .LDA.S  .DECR.S ;
: X--2 OVER DUP .LDA.S  .2DECR.S ;
: X--4 .PHA .SUB#  .STA.S(ZP) .PLA ;
: X--6 .PHA .SUB#  .STA.S(BASE),#
                                .PLA ;


\ *** LOCK O. 28, EXBLOCK 1C

\   CODEGEN: UNARY             27SEP90PZ

   ' ++X6 ' ++X4 ' ++X2 ' ++X0
INCOP DO-PREINC

   ' --X6 ' --X4 ' --X2 ' --X0
INCOP DO-PREDEC

   ' X++6 ' X++4 ' X++2 ' X++0
INCOP DO-POSTINC

   ' X--6 ' X--4 ' X--2 ' X--0
INCOP DO-POSTDEC


\ *** LOCK O. 29, EXBLOCK 1D

\ CODEGEN: BINARY              11SEP94PZ

VARIABLE TYP

: SETCONST ( -- )
     TYP @  %CONSTANT SET  TYP ! ;

    ' SETCONST ' SWAP ' NOOP ' DROP
CREATE CONST-VEC    , , , ,

: DO-BINOP ( OBJ1 OBJ2 VEC -- OBJ3 )
     VECTOR !
     %CONSTANT IS? 2 AND >R DROP  SWAP
     %CONSTANT IS? 4 AND R> OR >R DROP
     CONST-VEC R@ + PERFORM
     R> DOIT  TYP @ ;


\ *** LOCK O. 30, EXBLOCK 1E

\   CODEGEN: BINARY            11SEP94PZ

: DO-SHLA  ( OBJ1 -- OBJ2 )
     %CONSTANT IS?
       SWAP 2* SWAP  .SHLA  ;

: DO-SHRA  ( OBJ1 -- OBJ2 )
     %CONSTANT IS?
       SWAP 2/ SWAP  .SHRA  ;

CREATE ADD-VEC
  ' + ' .ADD# ' .ADD# ' .ADD , , , ,

: DO-ADD ( OBJ1 OBJ2 -- OBJ3 )
     2SWAP POINTER?
         DUP %CONSTANT CLR TYP !
        IS-INT? >R  2SWAP R>
            DO-SHLA 
         %DEFAULT TYP ! 
     ADD-VEC DO-BINOP ;

\ COMPLICATIONS ARE DUE TO POINTER
\ SCALING.


\ *** LOCK O. 31, EXBLOCK 1F

\   CODEGEN: BINARY            11SEP94PZ

VARIABLE SHRA-FLAG
CREATE SUB-VEC
  ' - ' .#SUB ' .SUB# ' .SUB , , , ,

: DO-SUB ( OBJ1 OBJ2 -- OBJ3 )
     SHRA-FLAG OFF  %DEFAULT TYP !
     2SWAP POINTER?
         DUP >R 2SWAP POINTER?
            IS-INT? R> IS-INT?
           NIP AND
               SHRA-FLAG ON 
            R> IS-INT?
           SWAP %CONSTANT CLR  TYP !
               DO-SHLA 
           
         2SWAP 
     SUB-VEC DO-BINOP
     SHRA-FLAG @  DO-SHRA  ;

\ COMPLICATIONS ARE DUE TO POINTER
\ SCALING.


\ *** LOCK O. 32, EXBLOCK 20

\   CODEGEN: BINARY            12SEP90PZ

: BINOP ( CFA3 CFA2 CFA1 CFA0 -- )
     CREATE , , , ,
    DOES>   ( OBJ1 OBJ2 VEC -- OBJ3 )
     %DEFAULT TYP !  DO-BINOP ;

   ' * ' .MULT# ' .MULT# ' .MULT
BINOP DO-MULT
   ' / ' .#DIV ' .DIV# ' .DIV
BINOP DO-DIV
   ' MOD ' .#MOD ' .MOD# ' .MOD
BINOP DO-MOD
   ' AND ' .AND# ' .AND# ' .AND
BINOP DO-AND
   ' XOR ' .XOR# ' .XOR# ' .XOR
BINOP DO-XOR
   ' OR ' .OR# ' .OR# ' .OR
BINOP DO-OR


\ *** LOCK O. 33, EXBLOCK 21

\   CODEGEN: BINARY            03SEP94PZ

\ > UND < SOLLTEN 0 ODER -1 ERGEBEN !

: <=  SWAP > ;
: >=  SWAP < ;
: !=  = 0= ;

   ' < ' .GT# ' .LT# ' .LT
BINOP DO-LT
   ' > ' .LT# ' .GT# ' .GT
BINOP DO-GT
   ' <= ' .GE# ' .LE# ' .LE
BINOP DO-LE
   ' >= ' .LE# ' .GE# ' .GE
BINOP DO-GE
   ' = ' .EQ# ' .EQ# ' .EQ
BINOP DO-EQ
   ' != ' .NE# ' .NE# ' .NE
BINOP DO-NE


\ *** LOCK O. 34, EXBLOCK 22

\   CODEGEN: BINARY            27SEP90PZ

: << ( N1 N2 -- N3 )
     0 ? 2*  ;
: >> ( N1 N2 -- N3 )
     0 ? 2/  ;

   ' << ' .#SHL ' .SHL# ' .SHL
BINOP DO-SHL
   ' >> ' .#SHR ' .SHR# ' .SHR
BINOP DO-SHR


\ *** LOCK O. 35, EXBLOCK 23

\   CODEGEN: BINARY            22FEB91PZ

: DO-L-AND.1 ( OBJ -- ADR )
     VALUE NON-CONSTANT  2DROP
     .JMZ-AHEAD
     RELEASE-ACCU ;

: DO-L-OR.1 ( OBJ -- )
     VALUE NON-CONSTANT  2DROP
     .JMN-AHEAD
     RELEASE-ACCU ;

: DO-L-AND/OR.2 ( ADR OBJ1 -- OBJ2 )
     VALUE NON-CONSTANT  2DROP
     .RESOLVE-JMP
     0 %DEFAULT ;


\ *** LOCK O. 36, EXBLOCK 24

\   CODEGEN: CONDITIONAL       22FEB91PZ

: IS0? ( OBJ -- OBJ FLAG )
     %CONSTANT IS? >R OVER 0= R> AND ;

: DO-COND1 ( OBJ1 -- ADR1 )
     VALUE NON-CONSTANT
     2DROP  RELEASE-ACCU
     .JMZ-AHEAD ;

: DO-COND2 ( ADR1 OBJ2 -- OBJ' ADR2 )
     VALUE IS0? -ROT NON-CONSTANT NIP
     ROT .JMP-AHEAD SWAP .RESOLVE-JMP
     RELEASE-ACCU ;

: DO-COND3 ( OBJ' ADR2 OBJ3 -- OBJ )
     VALUE IS0? -ROT NON-CONSTANT NIP
     ROT .RESOLVE-JMP
     2 PICK OVER XOR %COND.MASK AND 0=
         2DROP EXIT 
     OVER    2DROP EXIT 
     3 PICK  NIP NIP EXIT 
     2DROP DROP %DEFAULT
     *!=TYPE* ERROR ;


\ *** LOCK O. 37, EXBLOCK 25

\   CODEGEN: ASSIGN            27MAY91PZ

: PREPARE-ASGNOP ( OBJ1 -- OBJ2 OBJ3 )
     NEED-L-VALUE
     %CONSTANT %OFFSET + ISN'T?
         .PHA 
     2DUP %L-VALUE SET  VALUE ;

\ : PREPARE-ASSIGN ( OBJ1 -- OBJ2 )  NEED-L-VALUE ;
' NEED-L-VALUE ALIAS PREPARE-ASSIGN ( OBJ1 -- OBJ2 )

: DO-ASSIGN ( OBJ1 OBJ2 -- OBJ1 )
     ( VALUE ) NON-CONSTANT  2DROP
     ( 'OBJ2' IS ALWAYS 'VALUE' )
     SIZE? DUP .SIZE  1 =
         .AND#255 
     %CONSTANT IS?
         %CONSTANT CLR
        OVER .STA.S
         %OFFSET IS?
            %OFFSET CLR
           OVER .STA.S(BASE),#
            .POP-ZP .STA.S(ZP) 
         ;

OFF
