\ *** LOCK O. 100, EXBLOCK 64

\ INVOKE :  LOADSCREEN         21SEP94PZ

\ *** LOCK O. 101, EXBLOCK 65

\   INVOKE :  PASS1            11SEP94PZ

 : PASS1 ( -- )
     OPEN-OUTFILES
     ." SOURCE FILE: "
     SOURCE-NAME COUNT TYPE CR
     SOURCE-NAME OPEN-INPUT
     COMPILE-PROGRAM
     END-OF-CODE CLOSE-OUTFILES ;

 : ?USAGE  ( FLAG -- )
      ." USAGE: CC FILE.C" CR
     RDROP  ;


\ *** LOCK O. 102, EXBLOCK 66

\   INVOKE :  START COMPILER   11SEP94PZ

 : WAIT-SCRATCH  ( -- )
     DEV 15 BUSIN  BUS@ DROP
     I/O-STATUS?  BUSOFF ;

 : S!  COUNT BUSTYPE ;
 : ,!  ASCII , BUS! ;

 : SCRATCH-EXE  ( -- )
     DEV 15 BUSOUT " S0:" S!
     EXE-NAME S!        ,!
     EXE-NAME S! CODE.SUFFIX S! ,!
     EXE-NAME S! INIT.SUFFIX S! ,!
     EXE-NAME S! DECL.SUFFIX S!
     BUSOFF
     WAIT-SCRATCH ;


\ *** LOCK O. 103, EXBLOCK 67

\   INVOKE :  START COMPILER   13SEP94PZ

\ FORTH DEFINITIONS

 : CC  ( -- )
     CLEARSTACK
     \PROF PROFILER-START
     \TIME RESET-50MS-TIMER READ-50MS-TIMER
     INIT
     BL WORD   DUP C@ 0= ?USAGE
     DUP EXE-NAME STRCPY
         SOURCE-NAME STRCPY
     EXE-NAME COUNT 2-
     DUP EXE-NAME C!  + @
    [ ASCII . ASCII C 256 * + ] LITERAL
     -  ?USAGE
     SCRATCH-EXE
     CR CR ." PASS 1:" CR
     PASS1  CR
     ANY-ERRORS? @
         ." ERROR(S) OCCURED" CR
        CLOSE-FILES SCRATCHFILES EXIT
        
     \PROF PROFILER-TIMESTAMP
     ." PASS 2:" CR
     PASS2  CR
     ." COMPILATION DONE" CR
     SCRATCHFILES
     \TIME READ-50MS-TIMER - MS. CR
     \PROF PROFILER-END
     ;
