\ *** LOCK O. 12, EXBLOCK C

\ MEMMAN: LOADSCREEN           20SEP94PZ

\ TERMINOLOGY / INTERFACE:
\    HIMEM
\    HEAP[    ]HEAP
\    HASH[    ]HASH
\    SYMTAB[  ]SYMTAB
\    STATIC[  ]STATIC
\    CODE[    ]CODE
\    LINEBUF

\    /LINEBUF
\    #GLOBALS
\    /LINK
\    /SYMBOL
\    /ID

\    INIT-MEM

\    .MEM


\ *** LOCK O. 13, EXBLOCK D

\   MEMMAN: VARIABLE           03SEP94PZ

 CREATE CC64MEM  100   ,
( \ )      1000  , 4000  , 5000 ,
(           500   , 2000  , 8192 , )
              0 , 0 , 0 , 0 , 0 ,

  ' LIMIT ALIAS HIMEM

 : #LINKS        CC64MEM @ ;
  : #GLOBALS      CC64MEM 2+ @ ;
 : SYMTABSIZE    CC64MEM 4 + @ ;
 : CODESIZE      CC64MEM 6 + @ ;
  : LOMEM          R0 @ ;

 6 CONSTANT /LINK   \ LISTENKNOTEN

 4 CONSTANT /SYMBOL \ DATENFELDGROESSE

 31 CONSTANT /ID  \ DARF NICHT KLEINER
   \ ALS DAS KUERZESTE KEYWORD SEIN !!!

 133 CONSTANT /LINEBUF


\ *** LOCK O. 14, EXBLOCK E

\   MEMMAN: CONFIGURE          03SEP94PZ

' HIMEM
  ]HEAP
     : HEAP[    CC64MEM  8 + @ ;  ' HEAP[
  ]HASH
     : HASH[    CC64MEM 10 + @ ;  ' HASH[
  ]SYMTAB
     : SYMTAB[  CC64MEM 12 + @ ;  ' SYMTAB[
( \ )   ]CODE
( \ )      : CODE[    CC64MEM 14 + @ ;  ' CODE[
  ]STATIC
     : STATIC[  CC64MEM 16 + @ ;
 ' LOMEM    LINEBUF

(  : CODE[  $A000 ;       : ]CODE  $C000 ; )
(  : ENABLE-CODE[]-BANK ( -- ) 1 $9F61 C! ; )

 : (CONF?  ( -- FLAG )
     HIMEM  #LINKS /LINK *  -
                      DUP CC64MEM  8 + !
     #GLOBALS 2*  -   DUP CC64MEM 10 + !
     SYMTABSIZE -     DUP CC64MEM 12 + !
( DROP \ ) CODESIZE -  CC64MEM 14 + !
     LINEBUF /LINEBUF +   CC64MEM 16 + !
     STATIC[ 11 + ]STATIC U> ;


\ *** LOCK O. 15, EXBLOCK F

\   MEMMAN: .MEM               24AUG94PZ

 : CONFIGURE  ( -- )
     (CONF?   *MEMSETUP* ?FATAL ;

   INIT: CONFIGURE

 : SET-MEM:  ( N -- ) CREATE C, DOES>
  ( N DFA -- ) C@ CC64MEM + ! ;

 0 SET-MEM: #LINKS!
 2 SET-MEM: #GLOBALS!
 4 SET-MEM: SYMTABSIZE!
( \ )  6 SET-MEM: CODESIZE!

 : HIMEM!  ['] LIMIT >BODY ! ;


\  CREATE (DEFAULT-MEM  $20   ,
\                $10   , $100  , $100  ,

\  : DEFAULT-MEM  ( -- )
\   (DEFAULT-MEM CC64MEM 8 CMOVE CONFIGURE ;


\ *** LOCK O. 16, EXBLOCK 10

\   MEMMAN:                    09SEP94PZ

 : .BYTES  ( N -- )  . ." BYTES" CR ;

 : .MEM ( -- )
     (CONF? CR
    ." DATA STACK  : " S0 @ PAD - 256 -
                       .BYTES
    ." RETURN STACK: " R0 @ S0 @ -
                       .BYTES
    ." STATICBUFFER: " ]STATIC STATIC[
                       - .BYTES
    ." CODEBUFFER  : " CODESIZE  .BYTES
    ." SYMBOL TABLE: " SYMTABSIZE .BYTES
    ." HASH TABLE  : " #GLOBALS .
                       ." ELEMENTS" CR
    ." HEAP        : " #LINKS .
                       ." LINKS" CR
    ." MEMORY LIMIT: " HIMEM   U. CR
   
    ." BAD MEMORY SETUP: STATICBUFFER !"
   CR  ;


\ *** LOCK O. 17, EXBLOCK 11

\   MEMMAN:                    24AUG94PZ

 : RELOCATE-TASKS  ( NEW -- )
 UP@ DUP   1+ UNDER @ 2DUP -
   ROT DROP    2DROP ! ;

 : RELOCATE  ( STACKLEN RSTACKLEN -- )
 EMPTY  $100 MAX $2000 MIN  SWAP
 $100 MAX $2000 MIN  PAD + $100 +
 2DUP + 2+ LIMIT U>
 ABORT" STACKS BEYOND LIMIT"
 UNDER  +   ORIGIN $ + !        \ R0
 DUP RELOCATE-TASKS
 UP@ 1+ @   ORIGIN   1+ !        \ TASK
       6 -  ORIGIN  8 + ! COLD ; \ S0
