
8 CONSTANT #BUCKETS
4 CONSTANT #TIMESTAMPS

CREATE PREVIME  4 ALLOT
CREATE DELTAIME 4 ALLOT
VARIABLE CURRENTUCKET
VARIABLE CURRENTUCKETPEN
VARIABLE METRIC-NAME

CREATE <BUCKETS[    #BUCKETS 1+ ALLOT
CREATE >BUCKETS[    #BUCKETS 1+ ALLOT
CREATE <]BUCKETS    #BUCKETS 1+ ALLOT
CREATE >]BUCKETS    #BUCKETS 1+ ALLOT
CREATE BUCKETIMES  #BUCKETS 1+ 4 * ALLOT
CREATE BUCKETOUNTS #BUCKETS 1+ 4 * ALLOT

CREATE INITIALIMETAMP 4 ALLOT
CREATE TIMESTAMPS[  #TIMESTAMPS 4 * ALLOT
HERE CONSTANT ]TIMESTAMPS
VARIABLE TIMESTAMP>

CREATE MAINOUNT 4 ALLOT
CREATE COUNTSTAMPS[  #TIMESTAMPS 4 * ALLOT
HERE CONSTANT ]COUNTSTAMPS
VARIABLE COUNTSTAMPS>

SSEMBLER ALSO DEFINITIONS

: CALCIME
  SEC
  PREVIME 2+ LDA  TIMERLO SBC  DELTAIME 2+ STA
  PREVIME 3+ LDA  TIMERHI SBC  DELTAIME 3+ STA
  PREVIME    LDA  TIMERLO SBC  DELTAIME    STA
  PREVIME 1+ LDA  TIMERHI SBC  DELTAIME 1+ STA
;

: SETREVIME
  TIMERLO LDA  PREVIME 2+ STA
  TIMERHI LDA  PREVIME 3+ STA
  TIMERLO LDA  PREVIME    STA
  TIMERHI LDA  PREVIME 1+ STA
;

: ADDIMEOUCKET
  CLC
  BUCKETIMES 2+ ,X LDA  DELTAIME 2+ ADC  BUCKETIMES 2+ ,X STA
  BUCKETIMES 3+ ,X LDA  DELTAIME 3+ ADC  BUCKETIMES 3+ ,X STA
  BUCKETIMES    ,X LDA  DELTAIME    ADC  BUCKETIMES    ,X STA
  BUCKETIMES 1+ ,X LDA  DELTAIME 1+ ADC  BUCKETIMES 1+ ,X STA
;

: INCOUNTFUCKET
  BUCKETOUNTS 2+ ,X INC 0= ?[ BUCKETOUNTS 3+ ,X INC 0= ?[
     BUCKETOUNTS ,X INC 0= ?[ BUCKETOUNTS 1+ ,X INC  ]? ]? ]?
;

: INCAINOUNT
  MAINOUNT 2+ INC 0= ?[ MAINOUNT 3+ INC 0= ?[
     MAINOUNT INC 0= ?[ MAINOUNT 1+ INC  ]? ]? ]?
;

: COMPAREP
   1+ LDA  >BUCKETS[ ,X CMP  0= ?[  LDA  <BUCKETS[ ,X CMP ]?
;

: FINDUCKET
  0 # LDX  COMPAREP   ?[
    CURRENTUCKET LDX
  ][ INX  COMPAREP   ?[
      DEX
    ][
      5 # LDX
      COMPAREP  0<> ?[   ?[ DEX DEX ][ INX INX ]?
      COMPAREP  0<> ?[   ?[ DEX     ][ INX     ]?
      COMPAREP           ?[ DEX     ]?             ]? ]?

       1+ LDA  >]BUCKETS ,X CMP  0= ?[  LDA  <]BUCKETS ,X CMP ]?
         ?[ 0 # LDX ]?

      TXA  .A ASL  .A ASL  TAX
    ]?
    CURRENTUCKET STX
  ]?
;


ABEL PREXT
  TIMERCTRL LDA  PHA  $FE # AND  TIMERCTRL STA
  CALCIME
  FINDUCKET
  INCOUNTFUCKET
  ADDIMEOUCKET
  SETREVIME
  INCAINOUNT
  PLA  TIMERCTRL STA
  0 # LDX  CLC   LDA  EXT $C + JMP

ONLYFORTH

ODE INSTALL-PREXT
 PREXT 0 $100 M/MOD
     # LDA  EXT $B + STA
     # LDA  EXT $A + STA
 $4 # LDA  EXT $9 + STA
 EXT JMP  END-CODE

ODE END-PROFILER
 $18 # LDA  EXT $9 + STA
 $A5 # LDA  EXT $A + STA
   # LDA  EXT $B + STA
 EXT JMP   END-CODE


ODE INIT-PREVIME  SETREVIME  EXT JMP END-CODE

: PROFILER-INIT-BUCKETS
  CURRENTUCKET OFF  CURRENTUCKETPEN OFF  INIT-PREVIME
  <BUCKETS[    #BUCKETS 2+ $FF FILL
  >BUCKETS[    #BUCKETS 2+ $FF FILL
  <]BUCKETS    #BUCKETS 2+ $FF FILL
  >]BUCKETS    #BUCKETS 2+ $FF FILL
  ['] FORTH-83 >LO/HI >BUCKETS[ C! <BUCKETS[ C! ;

: PROFILER-BUCKET
  CREATE  LAST @ ,  0 , ;

: END-BUCKET  ( BUCKET -- )  HERE SWAP 2+ ! ;

: ACTIVATE-BUCKET  ( BUCKET -- )
  CURRENTUCKET @ 1+ DUP >R CURRENTUCKET ! \ CHECK FOR #BUCKETS
  DUP @ >LO/HI  >BUCKETS[ R@ + C!  <BUCKETS[ R@ + C!
  2+  @ >LO/HI  >]BUCKETS R@ + C!  <]BUCKETS R> + C! ;

: PROFILER-METRIC:[
  CREATE  LAST @ ,  HERE $0F ]  ( -- ADDR $0F )
  DOES> PROFILER-INIT-BUCKETS  DUP @ METRIC-NAME !  2+
   DUP @ ?DUP  EXECUTE ACTIVATE-BUCKET  2+  DROP ;

 : TOO-MANY-BUCKETS?  ( ADDR -- FLAG )  HERE SWAP -  #BUCKETS 2* > ;

 : UNORDERED-BUCKETS?  ( ADDR -- FLAG )
  >R ['] FORTH-83  R> DUP 2+ >R @ ?DUP 
    \ EXECUTE UNDER @ U>  RDROP @ COUNT TYPE TRUE EXIT 
    EXECUTE UNDER @ U>  RDROP DROP TRUE EXIT 
    2+ @  RDROP DROP FALSE ;

: ]PROFILER-METRIC  ( ADDR $0F -- ) $0F ?PAIRS  [COMPILE] [
  DUP TOO-MANY-BUCKETS? ABORT" TOO MANY BUCKETS IN METRIC"
  0 , UNORDERED-BUCKETS? ABORT" UNORDERED BUCKET" ; IMMEDIATE RESTRICT

: PROFILER-TIMESTAMP
  READ-32BIT-TIMER  TIMESTAMP> @
  DUP  4+ DUP ]TIMESTAMPS > ABORT" TOO MANY TIMESTAMPS"
  TIMESTAMP> !  2!
  MAINOUNT 2@  COUNTSTAMPS> @  DUP 4+ COUNTSTAMPS> !  2! ;

: PROFILER-START
  BUCKETIMES  #BUCKETS 1+ 4 * ERASE
  BUCKETOUNTS #BUCKETS 1+ 4 * ERASE
  PREVIME 4 ERASE   TIMESTAMPS[ TIMESTAMP> !
  MAINOUNT 4 ERASE  COUNTSTAMPS[ COUNTSTAMPS> !
  RESET-32BIT-TIMER  READ-32BIT-TIMER INITIALIMETAMP 2!
  INSTALL-PREXT ;

: PROFILER-END  END-PROFILER  PROFILER-TIMESTAMP ;

: D[].  ( ADDR  -- ) 2* 2* + 2@ 12 D.R ;

: BUCKET[  (  -- ADDR )
    <BUCKETS[ OVER + C@ SWAP >BUCKETS[ + C@ $100 * + ;

: ]BUCKET  (  -- ADDR )
    <]BUCKETS OVER + C@ SWAP >]BUCKETS + C@ $100 * + ;

: D..  ( D -- )
  <# # #S #>   SWAP DUP C@ EMIT 1+ SWAP 1- DUP 
  DUP 3 MOD 0=  ASCII . EMIT   2DROP BL EMIT ;

: PROFILER-REPORT
    CR ." PROFILER REPORT " METRIC-NAME @ COUNT $1F AND TYPE CR
    ." TIMESTAMPS" CR
    TIMESTAMPS[  DUP TIMESTAMP> @ < 
    DUP 2@ DNEGATE INITIALIMESTAMP 2@ D+ D.. 4+  DROP CR
    ." COUNTSTAMPS" CR
    COUNTSTAMPS[  DUP COUNTSTAMPS> @ < 
    DUP 2@ D.. 4+  DROP CR
    CR ." BUCKETS" CR
    ." B# ADDR[  ]ADDR  NEXTCOUNTS  CLOCKTICKS  NAME" CR
    #BUCKETS 1+ 0 
       .   BUCKET[ U.   ]BUCKET U.
      BUCKETOUNTS  D[].  BUCKETIMES  D[].
         BUCKET[ 1+  ."   "  BUCKET[ COUNT $1F AND TYPE 
       ."   (ETC)" 
      CR
     ;
