\ ENUMS AND STRING TABLES

 : ENUM ( -- NEXT-IDX 30 )  0 30 ;
 : Y ( LAST-IDX 30 -- NEXT-IDX 30 )
    30 ?PAIRS  DUP CONSTANT  1+ 30 ;
 : END-ENUM ( LAST-IDX 30 -- )  30 ?PAIRS  DROP ;

\  : >STRING  ( ADR -- STR )  @ ;
\  : +STRING  ( ADR1 -- ADR2/0 ) 2+ ;
 ' @ ALIAS >STRING  ( ADR -- STR )
 ' 2+ ALIAS +STRING  ( ADR1 -- ADR2 )
 : STRING[] ( TAB N -- ADR )  2* + 2+ ;

 : X ( NEXT-IDX 31 -- NEXT-IDX 32 )
    31 ?PAIRS  DUP CONSTANT  32 ;

 : X"  ( TAB LAST-IDX 32 -- TAB NEXT-IDX 31 )
    32 ?PAIRS
    2DUP STRING[] HERE SWAP !
    [COMPILE] ,"  1+ 31 ;

 : STRING-TAB ( SIZE -- TAB NEXT-IDX 31 )
     CREATE  HERE SWAP DUP ,  2* ALLOT  0 31 ;

 : END-TAB ( TAB NEXT-IDX 31 -- )
     31 ?PAIRS  OVER @ OVER -
        . ." ACTUAL SIZE" CR ABORT  2DROP  ;

 : LENGTH-INDEX  ( STRINGTAB MIN-IDX MAX-IDX -- STRINGTAB 33 )
     CREATE  C, C, DUP , 33 ;

 : END-INDEX  ( STRINGTAB 33 -- )
     33 ?PAIRS  @ C, ;

 ' C, ALIAS IDX,

 : FIND-VIA-INDEX  ( ADR IDXTBL -- FALSE )
                    ( ADR IDXTBL -- TOKEN TRUE )
     OVER C@  OVER C@ OVER ( ADR IDXTBL LEN IDXMAXLEN LEN )
     U<  DROP 2DROP FALSE EXIT  ( ADR IDXTBL LEN )
     OVER 1+ C@ - ( ADR IDXTBL LEN-IDXMINLEN )
     DUP 0<  DROP 2DROP FALSE EXIT 
     OVER + 4 + ( ADR IDXTBL IDXTBL[LEN-1] )
     SWAP >R DUP 1+ C@ SWAP C@  R> 2+ @ OVER STRING[] -ROT
     ( ADR STR[LEN-1] TOKEN[LEN-1] TOKEN[LEN] )
      ( ADR STR[LEN-1] )
       2DUP >STRING STREQ  2DROP  TRUE  EXIT 
       +STRING  2DROP FALSE ;
