\ *** LOCK O. 60, EXBLOCK 3C

\ SYMTAB: LOADSCREEN           20SEP94PZ

\ TERMINOLOGY / INTERFACE:
\ FINDLOCAL    PUTLOCAL
\ NESTLOCAL    UNNESTLOCAL
\ FINDGLOBAL   PUTGLOBAL
\ ( INIT-SYMTAB )

\ SYMBOL FORMAT:
\  [ NAME$(COUNTED)][ /SYMBOL BYTES DATA ]

\ SYMBOL TABLE FORMAT:
\  SYMTAB[//GLOBALS//   //LOCALS//]SYMTAB
\           GLOBALS>^   ^LOCALS>

\  HASH[////POINTERS TO GLOBALS/////]HASH

\ MARKS IN THE LOCAL SYMBOL TABLE:
\  END OF BLOCK LOCAL TABLE:  )BLOCK
\  END OF TOTAL LOCAL TABLE:  )LOCAL


\ *** LOCK O. 61, EXBLOCK 3D

\ SYMTAB: DIV.                 11MAR91PZ

 63 CONSTANT /NAME
 255 CONSTANT )LOCAL   \ MARKEN
 254 CONSTANT )BLOCK   \
\ ES MUSS /NAME < )BLOCK < )LOCAL < 256

 : CUTNAME ( NAME -- )
     DUP C@ /NAME UMIN SWAP C! ;

 CREATE DUMMY  /SYMBOL ALLOT

 VARIABLE GLOBALS>
 VARIABLE LOCALS>

 : INIT-SYMTAB
     HASH[ ]HASH OVER - ERASE
     SYMTAB[ GLOBALS> !
     ]SYMTAB 1-  )LOCAL OVER C!
     LOCALS> ! ;

    INIT: INIT-SYMTAB


\ *** LOCK O. 62, EXBLOCK 3E

\ SYMTAB: LOCALS               14FEB91PZ

 : (FINDLOC) ( NAME ENDMARK -- DFA/0 )
     ]SYMTAB LOCALS> @
     ? DUP  C@ > NOT
         2DROP 0  EXIT 
      C@ /NAME >  1
         OVER  STREQ
            2DROP  COUNT +
            EXIT 
         C@ 1+ /SYMBOL + 
     +  *COMPILER* FATAL ;

 : FINDLOCAL ( NAME -- DFA/0 )
     DUP CUTNAME  )LOCAL (FINDLOC) ;

 : FINDPARAM ( NAME -- DFA/0 )
     DUP CUTNAME  )BLOCK (FINDLOC) ;

 : SPACIOUS? ( N -- FLAG )
     LOCALS> @ GLOBALS> @ - U> 0= ;


\ *** LOCK O. 63, EXBLOCK 3F

\   SYMTAB: LOCALS             14FEB91PZ

 : PUTLOCAL ( NAME -- DFA )
     DUP C@ 0=  DROP DUMMY EXIT 
     DUP CUTNAME   DUP )BLOCK (FINDLOC)
         DROP DUMMY
        *DOUBLEDEF* ERROR  EXIT 
     DUP C@ 1+ /SYMBOL + SPACIOUS?
         LOCALS> @ /SYMBOL - UNDER
        OVER C@ 1+ UNDER - UNDER
        LOCALS> !  CMOVE
         DROP DUMMY
        *SYMOVFL* ERROR  ;

 : NESTLOCAL ( -- )
     1 SPACIOUS?  LOCALS> @ 1-
     )BLOCK OVER C!  LOCALS> !
      *SYMOVFL* ERROR  ;

 : UNNESTLOCAL ( -- )
     ]SYMTAB LOCALS> @ ?
      C@ )BLOCK =   1+ LOCALS> !
                    EXIT 
      *COMPILER* FATAL ;


\ *** LOCK O. 64, EXBLOCK 40

\ SYMTAB: GLOBALS              18FEB91PZ

 : HASH ( NAME -- N )
     0 SWAP COUNT BOUNDS
        ? 2*  C@ +  ;

\ TRUE/FALSE FLAG: FOUND NAME IN GLOBAL SYMBOLS
\ DFA: DATA FIELD ADDRESS OF FOUND SYMBOL
\ ADR: ADDRESS IN HASH TABLE FOR NAME
\ 0: HASH TABLE FULL
 : (FINDGLB) ( NAME -- DFA   TRUE )
              ( NAME -- ADR/0 FALSE )
     DUP HASH #GLOBALS U/MOD DROP
     2* HASH[ + DUP
       ]HASH U< NOT
         HASH[ > 
      @ ?DUP
         OVER STREQ
            DROP  @ COUNT +  TRUE
            EXIT 
         DROP   FALSE  EXIT
        
     2 + DROP 0  FALSE ;


\ *** LOCK O. 65, EXBLOCK 41

\   SYMTAB: GLOBALS            14FEB91PZ

 : FINDGLOBAL ( NAME -- DFA/0 )
     DUP CUTNAME  (FINDGLB) AND ;

 : PUTGLOBAL  ( NAME -- DFA )
     DUP C@ 0=  DROP DUMMY EXIT 
     DUP CUTNAME  DUP (FINDGLB)
         2DROP DUMMY
        *DOUBLEDEF* ERROR EXIT 
     ?DUP 0=
         DROP DUMMY
        *GLBOVFL* ERROR EXIT 
     OVER C@ 1+ /SYMBOL +  SPACIOUS?
         GLOBALS> @ SWAP !
        GLOBALS> @ OVER C@ 1+ CMOVE
        GLOBALS> @ COUNT +
        DUP  /SYMBOL + GLOBALS> !
         2DROP DUMMY
        *SYMOVFL* ERROR  ;
