
\ HIS IS A VARIANT OF THE REFERENCE IMPLEMENTATION TMPHEAP.FTH
\ WHICH PLACES ALL THE CODE FOR THE TMPHEAP ONTO THE HEAP,
\ JUST LIKE THE TRANSIENT 6502 ASSEMBLER TRNS6502ASM.FTH.
\ O AFTER A  OR , THE TMPHEAP CODE IS ALL GONE, WHICH IS
\ NICE SINCE THE COMPILED TURNKEY APPLICATION WILL LIKELY NOT NEED
\ IT ANYMORE, AND SO THE COMPILE TIME SPACE SAVING THAT TMPHEAP OFFERS
\ COMES AT ZERO COST IN TURNKEY APPLICATION SIZE.

HEAP CR .( TRNSTMPHEAP MAX END: ) U. CR

HERE

$200 HALLOT  HEAP DP !

VARIABLE TMPHEAP[
VARIABLE TMPHEAP>
VARIABLE ]TMPHEAP

UP@ DUP ]TMPHEAP !  DUP TMPHEAP> !  TMPHEAP[ !

: MK-TMP-HEAP  ( SIZE -- )
    HEAP DUP ]TMPHEAP ! TMPHEAP> !  HALLOT  HEAP TMPHEAP[ ! ;

: TMP-HALLOT  ( SIZE -- ADDR )
    TMPHEAP> @ SWAP -
    DUP TMPHEAP[ @ U< ABORT" TMP HEAP OVERFLOW"
    DUP TMPHEAP> ! ;

: TMP-HEAPMOVE   ( FROM FROM SIZE -- FROM OFFSET )
   DUP TMP-HALLOT  SWAP CMOVE
   TMPHEAP> @ OVER - ;

: TMP-HEAPMOVE1X   ( FROM SIZE -- FROM OFFSET )
   TMP-HEAPMOVE  ?HEADMOVE-XT OFF ;

:      ['] TMP-HEAPMOVE1X  ?HEADMOVE-XT ! ;
: ON   ['] TMP-HEAPMOVE    ?HEADMOVE-XT ! ;
: OFF  ?HEADMOVE-XT OFF ;


: REMOVE-TMP-WORDS-IN-VOC  ( VOC -- )
   DUP @ ?DUP   ( THREAD NEXT-IN-THREAD )
    DUP TMPHEAP[ @ ]TMPHEAP @ UWITHIN   ( THREAD NEXT-IN-THREAD )
      @ ?DUP  ( THREAD NEXT-NEXT-IN-THREAD ) OVER ! 
       ( THREAD ) OFF EXIT 
     ( THREAD NEXT-IN-THREAD ) NIP
    
   DROP ;

: REMOVE-TMP-WORDS  ( -- )
  VOC-LINK    @ ?DUP
    DUP 4 - REMOVE-TMP-WORDS-IN-VOC   ;

: TMP-CLEAR  ( -- )
  REMOVE-TMP-WORDS
  \ NCOMMENT THE FOLLOWING LINE TO HELP DETERMINE THE IDEAL TMPHEAP
  \ SIZE FOR YOUR PROJECT.
  \ TMPHEAP> @ TMPHEAP[ @ - CR U. ." SPARE TMPHEAP BYTES"
  ]TMPHEAP @ TMPHEAP> !  LAST OFF ;

HERE CR .( TRNSTMPHEAP ACT END: ) U. CR

DP !
