\ *** LOCK O. 84, EXBLOCK 54

\ VASSEMBLER LOADSCREEN        20SEP94PZ

\ ASSEMBLER FOR THE VIRTUAL MACHINE ON WHICH CODEGEN IS BASED
\ BASICALLS A SLIGHT ABSTRACTION, 16 BIT, OF THE 6502.

\ $ZP WIRD IMPLIZIT BENUTZT VON
\ - .NOT
\ - .MULT .MULT#
\ - .DIV  .DIV#  .#DIV
\ - .MOD  .MOD#  .#MOD
\ - .ADD .SUB .AND .OR  .XOR
\ - .EQ  .NE  .GE  .LT  .GT  .LE
\ - .JMN  .JMN-AHEAD
\ - .JMZ  .JMZ-AHEAD


\ *** LOCK O. 85, EXBLOCK 55

\   VASSEMBLER: RUNTIME        21AUG94PZ

ON

VARIABLE SIZE   2 SIZE !

VARIABLE O    $08C7 O !
\ HIBYTE: OFFSET-^ ^-LOBYTE: KENNBYTE
: RT ( -- )  O @ CONSTANT
         $0300 O +! ;
\ OFFS +=3-^ ^-KENNBYTE NICHT AENDERN

RT $JMP(ZP)
RT $SWITCH
RT $MULT
RT $DIVMOD
RT $SHL
RT $SHR
RT $JMP(LASTSTATIC)
RT $JMP(STACK)

\ *** LOCK O. 86, EXBLOCK 56

\   VASSEMBLER: PARAMETER      25MAY91PZ

$FF07 CONSTANT &
$FF17 CONSTANT &+1
  $27 CONSTANT <&
  $37 CONSTANT >&
  $47 CONSTANT $ZP
  $57 CONSTANT $ZP+1
  $67 CONSTANT $BASE
  $77 CONSTANT $BASE+1
: W:  $87 C, 21 ;
: ;W  21 ?PAIRS $97 C, ;
: B:  $A7 C, 22 ;
: ;B  22 ?PAIRS $B7 C, ;

: (WB:   ( PAR  ENDCODE -- STEP )
           >R NIP DUP  1+ DUP C@
           R@ =  SWAP - 1+ RDROP ;
          ( PAR  -- STEP )
: (;WB  2DROP 1 ;
: (W:   SIZE @ 2-  $97 (WB:
                     (;WB  ;
: (B:   SIZE @ 1-  $B7 (WB:
                     (;WB  ;


\ *** LOCK O. 87, EXBLOCK 57

\   VASSEMBLER: PARAMETER AUSW. 25MAY91PZ

           ( PAR  -- STEP )
: 0+W,   DROP     W,          2 ;
: 1+W,   DROP  1+ W,          2 ;
: <B,    DROP >LO B,          1 ;
: >B,    DROP >HI B,          1 ;
: ZP,    2DROP >ZP @    B,    1 ;
: ZP+1,  2DROP >ZP @ 1+ B,    1 ;
: BA,    2DROP >FRAME @    B, 1 ;
: BA+1,  2DROP >FRAME @ 1+ B, 1 ;
: RT,    1+ C@ >RUNTIME @ + W,
                          DROP  2 ;

: COMPILER-ERROR  *COMPILER* FATAL ;

CREATE ATAB
 ' 0+W, ,  ' 1+W, ,  ' <B, ,  ' >B, ,
 ' ZP, ,  ' ZP+1, ,  ' BA, ,  ' BA+1, ,
 ' (W: ,  ' (;WB ,   ' (B: ,  ' (;WB ,
 ' RT, ,
 ' COMPILER-ERROR DUP DUP , , ,


\ *** LOCK O. 88, EXBLOCK 58

\   VASSEMBLER: A: A&: ;A      26MAY91PZ

: (A: ( -- SYS )
     CREATE  HERE 0 C, 20 ASSEMBLER ;

: ;A ( SYS -- )
     20 ?PAIRS  CURRENT @ CONTEXT !
     HERE OVER - 1- SWAP C! ;

: A, ( PAR  B -- STEP )
     DUP $F AND $7 =
         2/ 2/ 2/ 2/ 2*
        ATAB + @ EXECUTE
         B, 2DROP 1  ;

: A&: (A: DOES> ( PAR PFA -- )
     COUNT BOUNDS
      DUP  DUP C@ A, + DROP ;

: A: (A: DOES> ( PFA -- )
     COUNT BOUNDS
      0  DUP C@ A, + ;


\ *** LOCK O. 89, EXBLOCK 59

\   VASSEMBLER: BASICS         26MAY91PZ

A&: .LDA#   <& # LDA  >& # LDX  ;A

A: .PHA     PHA TAY TXA PHA TYA  ;A
A: .PHA'    PHA     TXA PHA      ;A
A: .PLA     PLA     TAX PLA      ;A

' W,  .WORD
' B,  .BYTE

A&: .JSR    & JSR  ;A
A:  .JSR(ZP)  $JMP(ZP) JSR ;A
A:  .JSR(LASTSTATIC)  $JMP(LASTSTATIC) JSR ;A
A:  .JSR(STACK)  $JMP(STACK) JSR ;A
A:  .RTS    RTS ;A

A&: .LDY#   <& # LDY ;A
      ' .LDY#
 .ARGS

A: .SHLA  .A ASL TAY TXA
            .A ROL TAX TYA ;A
A: .SHRA  TAY TXA .A LSR
            TAX TYA .A ROR ;A
A: .AND#255  0 # LDX ;A


\ *** LOCK O. 90, EXBLOCK 5A

\   VASSEMBLER: BASICS         24MAY91PZ

A: .POP-ZP  TAY PLA $ZP+1 STA
                  PLA $ZP   STA  TYA ;A
A: .STA-ZP  $ZP STA  $ZP+1 STX ;A
A: .LDA-ZP  $ZP LDA  $ZP+1 LDX ;A

A: .LDA-BASE $BASE LDA $BASE+1 LDX ;A

A&: .LINK#  TAY CLC   $BASE LDA
              <& # ADC  $BASE STA
              $BASE+1 LDA  >& # ADC
              $BASE+1 STA  TYA ;A

A: .SWITCH  $SWITCH JSR ;A


\ *** LOCK O. 91, EXBLOCK 5B

\   VASSEMBLER: ARITHMETICS    27MAY91PZ

A: .NOT  $ZP STX  0 # LDX  $ZP ORA
           0= ?[ DEX ]? TXA ;A

A: .NEG  $FF # EOR TAY TXA
           $FF # EOR TAX
           INY 0= ?[ INX ]? TYA ;A

A: .INV  $FF # EOR TAY TXA
           $FF # EOR TAX TYA ;A


\ *** LOCK O. 92, EXBLOCK 5C

\   VASSEMBLER: ARITHMETICS    27MAY91PZ

A&: .ADD#   CLC  <& # ADC  TAY  TXA
              >& # ADC  TAX  TYA  ;A

A&: .SUB#   SEC  <& # SBC  TAY  TXA
              >& # SBC  TAX  TYA  ;A

A&: .#SUB   SEC  $FF # EOR  <& # ADC
              TAY  TXA  $FF # EOR
              >& # ADC  TAX  TYA  ;A

A&: .AND#   <& # AND  TAY  TXA
              >& # AND  TAX  TYA  ;A

A&: .OR#    <& # ORA  TAY  TXA
              >& # ORA  TAX  TYA  ;A

A&: .XOR#   <& # EOR  TAY  TXA
              >& # EOR  TAX  TYA  ;A


\ *** LOCK O. 93, EXBLOCK 5D

\   VASSEMBLER: ARITHMETICS    24MAY91PZ

A: .ADD-ZP  CLC  $ZP ADC  TAY  TXA
                 $ZP+1 ADC  TAX  TYA ;A

A: .SUB-ZP  SEC  $ZP SBC  TAY  TXA
                 $ZP+1 SBC  TAX  TYA ;A

A: .AND-ZP    $ZP AND  TAY  TXA
              $ZP+1 AND  TAX  TYA  ;A

A: .OR-ZP     $ZP ORA  TAY  TXA
              $ZP+1 ORA  TAX  TYA  ;A

A: .XOR-ZP    $ZP EOR  TAY  TXA
              $ZP+1 EOR  TAX  TYA  ;A

 : .ADD  .STA-ZP  .PLA  .ADD-ZP ;
 : .SUB  .STA-ZP  .PLA  .SUB-ZP ;
 : .AND  .STA-ZP  .PLA  .AND-ZP ;
 : .OR   .STA-ZP  .PLA  .OR-ZP  ;
 : .XOR  .STA-ZP  .PLA  .XOR-ZP ;


\ *** LOCK O. 94, EXBLOCK 5E

\   VASSEMBLER: ARITHMETICS    24MAY91PZ

A&: .LDZP#  TAY  <& # LDA    $ZP STA
                   >& # LDA  $ZP+1 STA
              TYA  ;A
A: (.MULT    $MULT   JSR ;A
A: (.DIVMOD  $DIVMOD JSR ;A

: .MULT#  .STA-ZP  .LDA#  (.MULT ;
: .MULT   .STA-ZP  .PLA   (.MULT ;

: .DIV#   .LDZP#  (.DIVMOD ;
: .#DIV   .STA-ZP  .LDA#  (.DIVMOD ;
: .DIV    .STA-ZP  .PLA   (.DIVMOD ;

: .MOD#   .DIV#  .LDA-ZP ;
: .#MOD   .#DIV  .LDA-ZP ;
: .MOD    .DIV   .LDA-ZP ;


\ *** LOCK O. 95, EXBLOCK 5F

\   VASSEMBLER: ARITHMETICS    27MAY91PZ

A: .TAY   TAY ;A
A: (.SHL  $SHL JSR ;A
A: (.SHR  $SHR JSR ;A

: .SHL   .TAY   .PLA   (.SHL ;
: .SHL#  .LDY#         (.SHL ;
: .#SHL  .TAY   .LDA#  (.SHL ;

: .SHR   .TAY   .PLA   (.SHR ;
: .SHR#  .LDY#         (.SHR ;
: .#SHR  .TAY   .LDA#  (.SHR ;

\ 'UNSIZED' IN/DECREMENTS
\  A&: .INCR  & INC  0= ?[ &+1 INC ]? ;A
\  A&: .DECR  & LDY  0= ?[ &+1 DEC ]?
\              & DEC ;A

\  A&: .2INCR  & LDY  $FE # CPY
\               CS ?[ &+1 INC ]?
\               & INC  & INC    ;A
\  A&: .2DECR  & LDY    2 # CPY
\               CC ?[ &+1 DEC ]?
\               & DEC  & DEC    ;A

\ *** LOCK O. 96, EXBLOCK 60

\   VASSEMBLER: ARITHMETICS    24MAY91PZ

A&: .CMP#  0 # LDY   >& # CPX
             SEC 0< ?[ CLC ]?
             0= ?[ <& # CMP ]? ;A

A: .CMP-ZP 0 # LDY   $ZP+1 CPX
             SEC 0< ?[ CLC ]?
             0= ?[ $ZP   CMP ]? ;A
 : .CMP .STA-ZP .PLA .CMP-ZP ;


A: (.EQ   0=  ?[ DEY ]? TYA TAX  ;A
A: (.NE   0<> ?[ DEY ]? TYA TAX  ;A
A: (.GE   CS  ?[ DEY ]? TYA TAX  ;A
A: (.LT   CC  ?[ DEY ]? TYA TAX  ;A
A: (.GT   CS  ?[ 0<> ?[ DEY ]? ]?
                          TYA TAX  ;A
A: (.LE   HERE 4 + BCC  0= ?[ DEY ]?
                          TYA TAX  ;A


\ *** LOCK O. 97, EXBLOCK 61

\   VASSEMBLER: ARITHMETICS    24MAY91PZ

: .EQ   .CMP    (.EQ ;
: .NE   .CMP    (.NE ;
: .EQ#  .CMP#   (.EQ ;
: .NE#  .CMP#   (.NE ;

: .GE   .CMP    (.GE ;
: .LT   .CMP    (.LT ;
: .GE#  .CMP#   (.GE ;
: .LT#  .CMP#   (.LT ;

: .GT   .CMP    (.GT ;
: .LE   .CMP    (.LE ;
: .GT#  .CMP#   (.GT ;
: .LE#  .CMP#   (.LE ;


\ *** LOCK O. 98, EXBLOCK 62

\   VASSEMBLER: 'SIZED'        18APR94PZ

: .SIZE  SIZE ! ;
\ EVTL NOCH BEI SIZE <>1,2 : ERROR

A&: .LDA#.S
   <& # LDA  W: >& # LDX ;W ;A


A&: .LDA.S
   & LDA W: &+1 LDX ;W B: 0 # LDX ;B ;A

A&: .STA.S  & STA  W: &+1 STX ;W ;A


A: .LDA.S(ZP)
   W: 1 # LDY  $ZP )Y LDA  TAX  DEY ;W
   B: 0 # LDX 0 # LDY ;B  $ZP )Y LDA ;A

A: .STA.S(ZP)
   0 # LDY  $ZP )Y STA  W: PHA TXA
       INY  $ZP )Y STA     PLA ;W ;A


\ *** LOCK O. 99, EXBLOCK 63

\   VASSEMBLER: 'SIZED'        18APR94PZ

A&: .LDA(BASE),&
   <& # LDY  $BASE )Y LDA  W: TAX DEY
             $BASE )Y LDA ;W
    B: 0 # LDX ;B ;A

: .LDA.S(BASE),#
      DUP 254 U>
         .LDA-BASE  .ADD#
           .STA-ZP    .LDA.S(ZP)
         SIZE @ 1-  1+ 
           .LDA(BASE),&  ;


A&: .STA(BASE),&
   <& # LDY  $BASE )Y STA  W: PHA TXA
        INY  $BASE )Y STA     PLA ;W ;A

: .STA.S(BASE),#
      DUP 254 U>
         .PHA'  .LDA-BASE  .ADD#
           .STA-ZP  .PLA  .STA.S(ZP)
         .STA(BASE),&  ;


\ *** LOCK O. 100, EXBLOCK 64

\   VASSEMBLER: 'SIZED'        27MAY91PZ

A&: .INCR.S
       & INC W: 0= ?[ &+1 INC ]? ;W ;A

A&: .DECR.S
       W: & LDY  0= ?[ &+1 DEC ]? ;W
       & DEC ;A

A&: .2INCR.S
       W: & LDY  $FE # CPY
       CS ?[ &+1 INC ]? ;W
       & INC  & INC ;A

A&: .2DECR.S
       W: & LDY    2 # CPY
       CC ?[ &+1 DEC ]? ;W
       & DEC  & DEC ;A


\ *** LOCK O. 101, EXBLOCK 65

\   VASSEMBLER: JUMPS          24MAY91PZ

A&: .JMP  & JMP ;A
       ' PC
 .LABEL

: .JMP-AHEAD    PC  0 .JMP ;
: .RESOLVE-JMP  PC SWAP 1+ W! ;

A: .SKIP0<>   $ZP STX  $ZP ORA
                HERE 5 + BNE ;A
A: .SKIP0=    $ZP STX  $ZP ORA
                HERE 5 + BEQ ;A

: .JMZ        .SKIP0<>  .JMP ;
: .JMN        .SKIP0=   .JMP ;

: .JMZ-AHEAD  .SKIP0<>  .JMP-AHEAD ;
: .JMN-AHEAD  .SKIP0=   .JMP-AHEAD ;

OFF
