
NLYFORTH  SSEMBLER ALSO DEFINITIONS

\ *** LOCK O. 122, EXBLOCK 7A

\ ORTH-83 6502-SSEMBLER      20OCT87RE

: END-CODE   CONTEXT 2- @  CONTEXT ! ;

REATE INDEX
$0909 , $1505 , $0115 , $8011 ,
$8009 , $10 , $8019 , $8080 ,
$0080 , $1404 , $8014 , $8080 ,
$8080 , $10 , $801 , $280 ,

ARIABLE MODE

: ODE:  ( N -)   REATE C,
  OES>  ( -)     C@ MODE ! ;

0   ODE: .        1    ODE: #
2   ODE: MEM       3    ODE: ,
4   ODE: ,        5    ODE: )
6   ODE: )       $    ODE: )


\ *** LOCK O. 123, EXBLOCK 7B

\ UPMODE  CPU                  20OCT87RE

: UPMODE ( ADDR0 F0 - ADDR1 F1)
  MODE @  8 OR MODE !   
 1 MODE @  $ AND ?DUP 
 0   DUP +   
 OVER 1+ @ AND 0= ;

: CPU  ( 8B -)   REATE  C,
  OES>  ( -)    C@ C, MEM ;

 00 CPU BRK $18 CPU CLC $8 CPU CLD
$58 CPU CLI $8 CPU CLV $ CPU DEX
$88 CPU DEY $8 CPU INX $8 CPU INY
$ CPU NOP $48 CPU PHA $08 CPU PHP
$68 CPU PLA $28 CPU PLP $40 CPU RTI
$60 CPU RTS $38 CPU SEC $8 CPU SED
$78 CPU SEI $ CPU TAX $8 CPU TAY
$ CPU TSX $8 CPU TXA $9 CPU TXS
$98 CPU TYA


\ *** LOCK O. 124, EXBLOCK 7C

\ M/CPU                        20OCT87RE

: M/CPU  ( MODE OPCODE -)  REATE C, ,
 OES>
 DUP 1+ @ $80 AND  $10 MODE +! 
 OVER $00 AND UPMODE UPMODE
  MEM TRUE BORT" INVALID" 
 C@ MODE @ INDEX + C@ + C, MODE @ 7 AND
  MODE @  $ AND 7 <
   C,  ,   MEM ;

$16 $60 M/CPU ADC $16 $20 M/CPU AND
$16 $0 M/CPU CMP $16 $40 M/CPU EOR
$16 $0 M/CPU LDA $16 $00 M/CPU ORA
$16 $0 M/CPU SBC $16 $80 M/CPU STA
$00 $01 M/CPU ASL $00 $1 M/CPU DEC
$00 $1 M/CPU INC $00 $41 M/CPU LSR
$00 $21 M/CPU ROL $00 $61 M/CPU ROR
$0414 $81 M/CPU STX $0486 $0 M/CPU CPX
$0486 $0 M/CPU CPY $1496 $2 M/CPU LDX
$08 $0 M/CPU LDY $048 $80 M/CPU STY
$0480 $14 M/CPU JSR $8480 $40 M/CPU JMP
$0484 $20 M/CPU BIT


\ *** LOCK O. 125, EXBLOCK 7D

\ SSEMBLER CONDITIONALS       20OCT87RE

: RANGE?   ( BRANCH -- BRANCH )
 DUP ABS  $7 U> BORT" OUT OF RANGE " ;

: [[  ( )  HERE ;

: ?]  ( )  C, HERE 1+ - RANGE? C, ;

: ?[  ( )     C,  HERE 0 C, ;

: ?[[ ( )  ?[ SWAP ;

: ]?  ( )   HERE OVER C@   SWAP !
  OVER 1+ - RANGE? SWAP C!  ;

: ][  ( )   HERE 1+   1 JMP
 SWAP HERE OVER 1+ - RANGE?  SWAP C! ;

: ]]  ( )  JMP ;

: ]]? ( ) JMP ]? ;


\ *** LOCK O. 126, EXBLOCK 7E

\ SSEMBLER CONDITIONALS       20OCT87RE

$90 ONSTANT      $0 ONSTANT 
$0 ONSTANT 0=     $0 ONSTANT 0<>
$10 ONSTANT 0<     $30 ONSTANT 0>=
$50 ONSTANT      $70 ONSTANT 

: NOT    $20 [ ORTH ] XOR ;

: BEQ    0<> ?] ;   : BMI   0>= ?] ;
: BNE    0=  ?] ;   : BPL   0<  ?] ;
: BCC      ?] ;   : BVC     ?] ;
: BCS      ?] ;   : BVS     ?] ;


\ *** LOCK O. 127, EXBLOCK 7F

\ 2INC/2DEC   WINC/WDEC        20OCT87RE

: 2INC  ( ADR -- )
 DUP LDA  CLC  2 # ADC
 DUP STA   ?[  SWAP 1+ INC  ]?  ;

: 2DEC  ( ADR -- )
 DUP LDA  SEC  2 # SBC
 DUP STA   ?[  SWAP 1+ DEC  ]?  ;

: WINC  ( ADR -- )
 DUP INC  0= ?[  SWAP 1+ INC  ]?  ;

: WDEC  ( ADR -- )
 DUP LDA  0= ?[  OVER 1+ DEC  ]?  DEC  ;

: ;C:
 RECOVER JSR  END-CODE ]  0 LAST !  0 ;


\ *** LOCK O. 128, EXBLOCK 80

\ ;CODE ODE CODE>          BP/RE03FEB85

NLYFORTH

: SSEMBLER
 SSEMBLER   [ SSEMBLER ] MEM ;

: ;ODE
 [COMPILE] OES>  -3 ALLOT
 [COMPILE] ;      -2 ALLOT   SSEMBLER ;
IMMEDIATE

: ODE  REATE HERE DUP 2- ! SSEMBLER ;

: >LABEL  ( ADR -)
 HERE  REATE  IMMEDIATE  SWAP ,
 4 HALLOT HEAP 1 AND HALLOT ( 6502-ALIG)
 HERE 4 - HEAP  4  CMOVE
 HEAP LAST @ COUNT $1 AND + !  DP !
  OES>  ( - ADR)   @
  STATE @   [COMPILE] ITERAL   ;

: ABEL
 [ SSEMBLER ]  HERE >LABEL SSEMBLER ;

NLYFORTH
