\ *** LOCK O. 72, EXBLOCK 48

\ CODEHANDLER: LOADSCREEN      20SEP94PZ

\ TERMINOLOGY / INTERFACE:

\ FUER PROGRAMMCODE:
\ B!  W!  B,  W,  PC  *=  FLUSHCODE

\ FUER STATISCHE VARIABLE:
\ CSTAT,  STAT,  >STATICADR  STATICADR>
\ FLUSHSTATIC

\ FUER DYNAMISCHE VARIABLE:
\ DYN-OFFS  DYN-RESET  DYN-ALLOT

\ FUER CODELAYOUT:
\ LIB.FIRST          CODELAYOUT.OK
\ CODE.FIRST         END-OF-CODE
\ CODE.LAST
\ STATICS.FIRST
\ STATICS.LIBFIRST
\ STATICS.LAST


\ *** LOCK O. 73, EXBLOCK 49

\   CODEHANDLER: DYNAMICS,INIT 19APR94PZ

 VARIABLE >TOS-OFFS

 : DYN-OFFS  ( -- OFFS )  >TOS-OFFS @ ;

 : DYN-RESET  ( -- )  >TOS-OFFS OFF ;

 : DYN-ALLOT ( N -- OFFS )
     DYN-OFFS  SWAP >TOS-OFFS +! ;


 DOER FLUSHCODE ( -- )

 DOER FLUSHSTATIC ( -- )


 VARIABLE NOLAYOUT

 : INIT-CODEHANDLER  NOLAYOUT ON ;

   INIT: INIT-CODEHANDLER


\ *** LOCK O. 74, EXBLOCK 4A

\   CODEHANDLER: CODE          19APR94PZ

 VARIABLE >PC
 : PC  >PC @ ;

 VARIABLE CODEOFFSET
 : CLEARCODE ( -- )
     PC CODE[ - CODEOFFSET ! ;
 : *=   >PC !  CLEARCODE ;

 : >CODEADR ( PC-ADR -- CODE-BUF-ADR )
    NOLAYOUT @  *NOLAYOUT* ?FATAL
    ( ENABLE-CODE[]-BANK )
    CODEOFFSET @ - DUP
    CODE[ ]CODE 1- UWITHIN
    0= *FUNCTOOLONG* ?FATAL ;

 : B! ( 8B PC-ADR -- )  >CODEADR C! ;
 : W! ( 16B PC-ADR -- )  >CODEADR ! ;

 : B,  ( 8B -- )     PC B! 1 >PC +! ;
 : W,  ( 16B -- )    PC W! 2 >PC +! ;


\ *** LOCK O. 75, EXBLOCK 4B

\   CODEHANDLER: STATICS       19APR94PZ

 VARIABLE STATIC-OFFSET
 VARIABLE STATIC>

 : CLEARSTATIC ( -- )
   STATIC[ STATIC> ! ;

 : STATICADR> ( -- CURRENT.ADRESS )
     NOLAYOUT @  *NOLAYOUT* ?FATAL
     STATIC-OFFSET @ STATIC> @ - ;

 : >STATICADR ( ADR -- )
     CLEARSTATIC
     STATIC> @ + STATIC-OFFSET ! ;

 : CSTAT, ( 8B -- )
     STATIC> @ C!  1 STATIC> +!
     STATIC> @ ]STATIC U< NOT
         FLUSHSTATIC  ;

 : STAT, ( 16B -- )
     >LO/HI CSTAT, CSTAT, ;


\ *** LOCK O. 76, EXBLOCK 4C

\   CODEHANDLER : CODELAYOUT   11SEP94PZ

 VARIABLE LIB.FIRST
 VARIABLE CODE.FIRST
 VARIABLE CODE.LAST
 VARIABLE STATICS.FIRST
 VARIABLE STATICS.LIBFIRST
 VARIABLE STATICS.LAST
 VARIABLE LIB.CODENAME  15 ALLOT
 VARIABLE LIB.INITNAME  15 ALLOT

 CREATE CODE.SUFFIX ," .O"
 CREATE INIT.SUFFIX ," .I"
 CREATE DECL.SUFFIX ," .H"
 : CUT-SUFFIX  ( STR -- )
     DUP C@ 2- SWAP C! ;

 : CODELAYOUT.OK  NOLAYOUT OFF ;

 : END-OF-CODE  ( -- )
     FLUSHSTATIC
     FLUSHCODE
     STATICADR> STATICS.FIRST !
     PC         CODE.LAST     ! ;

\ *** LOCK O. 77, EXBLOCK 4D

\ CODEOUTPUT: FLUSHCODE/STATIC 11SEP94PZ

MAKE FLUSHCODE ( -- )
   CODE-FILE FSETOUT
   CODE[  PC >CODEADR  OVER -  FPUTS
   FUNSET  CLEARCODE ;

MAKE FLUSHSTATIC ( -- )
   STATIC-FILE FSETOUT
   STATIC[  STATIC> @  OVER - FPUTS
   STATIC[ STATIC> @ - STATIC-OFFSET +!
   FUNSET  CLEARSTATIC ;

\ NOCH SCHLECHT MODULARISIERT:
\    GREIFT AUF INTERNE WORTE DES
\    CODEHANDLERS ZURUECK.
