\ *** LOCK O. 18, EXBLOCK 12

\ VARIABLES & LOADSCREEN       14SEP94PZ

 17 CONSTANT /FILENAME

  VARIABLE 1.COLUMN
  VARIABLE CHAR
  VARIABLE VIR-CHAR
  VARIABLE BLANKLINES
  CREATE FILENAME  /FILENAME ALLOT
  VARIABLE CHANGED?
  VARIABLE END?

 VARIABLE 1ST-LINE>
 VARIABLE LINE>
 VARIABLE )TEXT
 VARIABLE TEXT(
 VARIABLE LAST-LINE>

 : CHAR>  LINE> @ CHAR @ + ;


\ *** LOCK O. 19, EXBLOCK 13

\   DISPLAY                    02AUG94PZ

 CREATE CSTAB
   $80 C,  $00 C,  $40 C,  $20 C,
   $C0 C,  $40 C,  $80 C,  $80 C,

 : CBM>SCR  ( 8B1 -- 8B2 )
     DUP $FF =  DROP $5E EXIT 
     DUP $E0 AND 2/ 2/ 2/ 2/ 2/
     CSTAB + C@ - $FF AND ;


\ *** LOCK O. 20, EXBLOCK 14

\   DISPLAY                    02SEP94PZ

 : KEY ( -- C )
      PAUSE C64KEY?  GETKEY ;

 40   CONSTANT COL/SCR
(64  1024 CONSTANT SCR> )
(16  3072 CONSTANT SCR> )
\  1024 CONSTANT CHR/SCR
 SCR> 1000 +    CONSTANT <SCR
 <SCR COL/SCR - CONSTANT LAST-ROW>
 ' SCR>  1ST-ROW>
 25   CONSTANT ROWS/SCR

 VARIABLE CSR.ROW>
 VARIABLE CSR.COL

 : COL/SCR*  2* 2* 2* DUP 2* 2* + ;
 : TH-ROW>  ( N -- ADR )
     COL/SCR* SCR> + ;

 : CURSOR> ( -- ADR )
     CSR.ROW> @ CSR.COL @ + ;
 : FLIP  ( -- ) $80 CURSOR> CTOGGLE ;


\ *** LOCK O. 21, EXBLOCK 15

\   DISPLAY                    02SEP94PZ

 : (.LINE  ( LINE ROW -- )
     SWAP 1.COLUMN @ 0 ? DUP C@ #CR =
         DROP COL/SCR BL FILL
         EXIT   1+ 
     ( ROW LINE ) OVER COL/SCR BOUNDS
      ( ROW LINE ) DUP C@ DUP #CR =
         2DROP COL/SCR +  ?
        BL  C!   EXIT 
     CBM>SCR  C! 1+  2DROP ;

(64  $D020 CONSTANT BORDER )
(16  $FF19 CONSTANT BORDER )
 : HALF  ( N - )
     BORDER C! PAUSE $80 0   ;

     0 CONSTANT BLACK
(64  1 CONSTANT WHITE )
(16  $71 CONSTANT WHITE )
 : WARN-SIGNAL ( -- )
     BORDER PUSH  WHITE HALF  BLACK HALF
                  WHITE HALF  BLACK HALF ;


\ *** LOCK O. 22, EXBLOCK 16

\ ERE LIVED THE ASSEMBLER IMPLEMENTATION OF >PREV/>NEXTLINE.

\ *** LOCK O. 23, EXBLOCK 17

\   DISPLAY                    02SEP94PZ

 : >PREVLINE  ( LINE> -- LINE'> )
     DUP TEXT( @ =
         DROP LINE> @ EXIT 
     1-  DUP TEXT( @ = ?EXIT
              DUP TEXT[   = ?EXIT
     1- DUP C@ #CR =  1+ ;

 : >NEXTLINE  ( LINE> -- LINE'> )
      DUP C@ #CR -  1+ 
     1+ DUP )TEXT @ =
         DROP TEXT( @  ;

\  : >PREVLINE ( LINE> -- LINE'> )
\      DUP  >PREVLINE1
\      SWAP (>PREVLINE  OVER -
\          WARN-SIGNAL  ;

\  : >NEXTLINE ( LINE> -- LINE'> )
\      DUP  >NEXTLINE1
\      SWAP (>NEXTLINE  OVER -
\          WARN-SIGNAL  ;


\ *** LOCK O. 24, EXBLOCK 18

\   DISPLAY                    31AUG94PZ

 : SETCUR ( SCRLINE -- )
     CSR.ROW> !
     CHAR @ 1.COLUMN @ - CSR.COL !
     FLIP ;

\ : .LINE ( -- )
\    CSR.ROW> @  LINE> @ OVER
\    (.LINE SETCUR ;

 : .SCREEN ( -- )
     1ST-LINE> @   <SCR SCR>
      DUP  (.LINE
     DUP LINE> @ =   SETCUR 
     >NEXTLINE DUP ]TEXT 1- =
         >PREVLINE LAST-LINE> !
         COL/SCR +  <SCR OVER -
        DUP COL/SCR / BLANKLINES !
        BL FILL  EXIT 
     COL/SCR +
     >PREVLINE LAST-LINE> !
     BLANKLINES OFF ;


\ *** LOCK O. 25, EXBLOCK 19

\   DISPLAY                    31AUG94PZ

 : SCROLL-RIGHT? ( --  FLAG )
     CSR.COL @ 0= ;

 : SCROLL-LEFT? ( --  FLAG )
     CSR.COL @ COL/SCR 1- = ;

 8 CONSTANT #TAB

 : SCROLL-LEFT ( -- )
     #TAB 1.COLUMN +!    .SCREEN ;

 : SCROLL-RIGHT ( -- )
     1.COLUMN @ #TAB UMIN
     NEGATE 1.COLUMN +!  .SCREEN ;


 : MEM?  ( N -- FLAG )
     )TEXT @ + TEXT( @ U>
     DUP  WARN-SIGNAL  ;


\ *** LOCK O. 26, EXBLOCK 1A

\   DISPLAY                    14SEP94PZ

 : .CHAR ( C -- )  VIR-CHAR OFF
     1 MEM? ?EXIT   CHANGED? ON
     SCROLL-LEFT?  SCROLL-LEFT 
     CHAR> DUP 1+  )TEXT @ 1+
     DUP )TEXT !   OVER - CMOVE>
     DUP CHAR> C!  1 CHAR +!
     FLIP  CURSOR> DUP 1+
     COL/SCR CSR.COL @ - 1- CMOVE>
     CBM>SCR  CURSOR> C!
     1 CSR.COL +!  FLIP ;

 : .LEFT  ( -- )   VIR-CHAR OFF
     CHAR @ 0= ?EXIT
     SCROLL-RIGHT?  SCROLL-RIGHT 
     -1 CHAR +!
     FLIP -1 CSR.COL +! FLIP ;

 : .RIGHT  ( -- )  VIR-CHAR OFF
     CHAR> 1+ )TEXT @ = ?EXIT
     SCROLL-LEFT?  SCROLL-LEFT 
     1 CHAR +!
     FLIP  1 CSR.COL +!  FLIP ;


\ *** LOCK O. 27, EXBLOCK 1B

\   DISPLAY                    14SEP94PZ

 : 1ST-LINE-UP ( -- )
     1ST-LINE> @ >PREVLINE
     1ST-LINE> ! ;

 : 1ST-LINE-DOWN ( -- )
     1ST-LINE> @ >NEXTLINE
     1ST-LINE> ! ;

 : LAST-LINE-UP ( -- )
     BLANKLINES @
         -1 BLANKLINES +!
         LAST-LINE> @
        >PREVLINE LAST-LINE> !  ;

 : LAST-LINE-DOWN ( -- )
     LAST-LINE> @ >NEXTLINE
     DUP ]TEXT 1- =  1 BLANKLINES +!
                    DROP EXIT 
     LAST-LINE> ! ;


\ *** LOCK O. 28, EXBLOCK 1C

\   DISPLAY                    31AUG94PZ

 : .VIR-LEFT  ( -- )
     )TEXT @ LINE> @ - 1- >R
     VIR-CHAR @ 0=
         CHAR @ R@ U>
            CHAR @ VIR-CHAR !
            RDROP EXIT   
     VIR-CHAR @  DUP R> UMIN CHAR @ -
     ?DUP 0=  DROP EXIT  >R
     R@ CHAR @ + DUP CHAR !
     OVER = 0= AND VIR-CHAR !
     R@ CSR.COL @ +  DUP COL/SCR <
     SWAP -1 > AND
         FLIP R> CSR.COL +! FLIP
         1.COLUMN @ R> +
        DUP 0<  CSR.COL +!
               1.COLUMN OFF
                1.COLUMN ! 
        .SCREEN  ;


\ *** LOCK O. 29, EXBLOCK 1D

\   DISPLAY                    13SEP94PZ

 : (DEL-LINE  ( LINE -- )
     DUP COL/SCR + UNDER
     <SCR SWAP - CMOVE
     LAST-ROW> COL/SCR BL FILL ;

 : LINE-UP  ( -- )
     TEXT( @  DUP LAST-LINE> @ = >R
              ( FROM )   DUP >NEXTLINE
     DUP TEXT( !         OVER - >R
     )TEXT @ ( FROM TO ) DUP LINE> !
     DUP R@ + )TEXT !    R> CMOVE
     R>  LINE> @ LAST-LINE> !  ;

 : .DOWN ( -- )
     TEXT( @ 1+ ]TEXT = ?EXIT
     LINE-UP
     FLIP  CSR.ROW> @ LAST-ROW> =
         SCR> (DEL-LINE
        1ST-LINE-DOWN LAST-LINE-DOWN
        LAST-LINE> @ LAST-ROW> (.LINE
         COL/SCR CSR.ROW> +! 
     FLIP  .VIR-LEFT ;


\ *** LOCK O. 30, EXBLOCK 1E

\   DISPLAY                    13SEP94PZ

 : (INST-LINE  ( LINE -- )
     DUP  DUP COL/SCR +
     <SCR OVER - CMOVE>
          COL/SCR BL FILL ;

 : LINE-DOWN  ( -- )
     LINE> @  DUP LAST-LINE> @ = >R
             )TEXT @ OVER - >R
     TEXT( @ R@ -  DUP TEXT( !
     R>  CMOVE>   LINE> @ DUP )TEXT !
     >PREVLINE LINE> !
     R>  TEXT( @ LAST-LINE> !  ;

 : .UP ( -- )
     LINE> @ TEXT[ = ?EXIT
     LINE-DOWN
     FLIP  CSR.ROW> @ SCR> =
         1ST-LINE-UP LAST-LINE-UP
        SCR> (INST-LINE
        1ST-LINE> @ SCR> (.LINE
         COL/SCR NEGATE
        CSR.ROW> +! 
     FLIP  .VIR-LEFT ;


\ *** LOCK O. 31, EXBLOCK 1F

\   DISPLAY                    14SEP94PZ

 : .DEL-FROM  ( -- )
     VIR-CHAR OFF  CHANGED? ON
     CHAR> #CR OVER C!  1+ )TEXT !
     CURSOR> COL/SCR CSR.COL @ -
     BL FILL  FLIP ;

 : .DEL-TO  ( -- )
     VIR-CHAR OFF  CHANGED? ON
     LINE> @ CHAR> OVER - BL FILL
     CSR.ROW> @ CSR.COL @ BL FILL ;

 : .DEL-LINE  ( -- )
     .DEL-TO .DEL-FROM ;


\ *** LOCK O. 32, EXBLOCK 20

\   DISPLAY                    14SEP94PZ

 : (SPLIT-MEM  ( -- )
     CHAR> )TEXT @ OVER -  OVER 1+ SWAP
     CMOVE>  #CR CHAR> C!  1 )TEXT +!
     CHAR> 1+ LINE> !  CHAR OFF ;

 : .SPLIT-LINE ( -- )  VIR-CHAR OFF
     1 MEM? ?EXIT   CHANGED? ON
     LINE> @ LAST-LINE> @ =  (SPLIT-MEM
         CHAR> LAST-LINE> !
        BLANKLINES @
            -1 BLANKLINES +!
            1ST-LINE-DOWN 
         LAST-LINE-UP 
     1.COLUMN @  1.COLUMN OFF
                .SCREEN EXIT 
     CURSOR> COL/SCR CSR.COL @ - BL FILL
     CSR.COL OFF
     CSR.ROW> @ LAST-ROW> =
         1ST-ROW> (DEL-LINE
         COL/SCR CSR.ROW> +!
        CSR.ROW> @ (INST-LINE 
     LINE> @ CSR.ROW> @ (.LINE  FLIP ;


\ *** LOCK O. 33, EXBLOCK 21

\   DISPLAY                    15SEP94PZ

 : (JOIN-MEM  ( -- )
     LINE> @  DUP >PREVLINE >R
     DUP R@ - 1- CHAR !
( LINE )    )TEXT @ OVER -   OVER 1-
( LINE LEN LINE-1 ) SWAP CMOVE   ( -- )
     -1 )TEXT +!   R> LINE> !  ;

 : (JOIN-1STLAST  ( N -- )
     0 CASE?  LAST-LINE-DOWN EXIT 
     2 CASE?  TEXT( @ 1+ ]TEXT =
                 LINE> @ LAST-LINE> !
                1 BLANKLINES +!
                 TEXT( @
                LAST-LINE> ! 
             EXIT 
     1 =      LINE> @ 1ST-LINE> !
             EXIT 
     LINE> @ DUP 1ST-LINE> !
     LAST-LINE> ! 1 BLANKLINES +! ;


\ *** LOCK O. 34, EXBLOCK 22

\   DISPLAY                    14SEP94PZ

 : .JOIN-LINES  ( -- )  VIR-CHAR OFF
     LINE> @ TEXT[ = ?EXIT
     CHANGED? ON
     LINE> @ 1ST-LINE>  @ =  1 AND
     LINE> @ LAST-LINE> @ =  2 AND OR
     (JOIN-MEM   (JOIN-1STLAST
     CHAR @ 1.COLUMN @ -    ( CSR.COL )
     DUP COL/SCR U<
         CSR.COL !
        CSR.ROW> @  1ST-ROW> -
            CSR.ROW> @ (DEL-LINE
           COL/SCR NEGATE CSR.ROW> +!
           BLANKLINES @ 0=
               LAST-LINE> @ LAST-ROW>
              (.LINE 
           
        LINE> @ CSR.ROW> @ (.LINE FLIP
         COL/SCR - #TAB +
        1.COLUMN +! .SCREEN  ;


\ *** LOCK O. 35, EXBLOCK 23

\   DISPLAY                    14SEP94PZ

 : .DEL-UNDER  ( -- )  VIR-CHAR OFF
     CHAR> C@ #CR = ?EXIT
     CHANGED? ON
     CHAR> DUP 1+ SWAP )TEXT @ 1-
     DUP )TEXT !  OVER - CMOVE
     CURSOR> DUP 1+ SWAP
     COL/SCR CSR.COL @ - 1- CMOVE
     LINE> @ 1.COLUMN @ + COL/SCR + 1-
     DUP )TEXT @ 1- U<
         C@  DROP BL  CBM>SCR
     CSR.ROW> @ COL/SCR + 1- C!
     FLIP ;

 : .DEL-LEFT  ( -- )
     CSR.COL @
         .LEFT .DEL-UNDER
         .JOIN-LINES   ;


\ *** LOCK O. 36, EXBLOCK 24

\   FOLD/UNFOLD                31AUG94PZ

 : UNFOLD  ( -- )
     CHAR OFF  1.COLUMN OFF
     TEXT[ DUP 1ST-LINE> ! DUP LINE> !
     >NEXTLINE DUP TEXT( @ =
         DROP EXIT    ( FROM )
     )TEXT @ OVER - >R  DUP )TEXT !
     TEXT( @ R@ -       DUP TEXT( !
     R> CMOVE> ;

\  : FOLD  ( -- )
\      TEXT( @  ]TEXT 1- OVER -
\      ?DUP 0=  DROP EXIT 
\      )TEXT @ SWAP   DUP )TEXT +!
\      CMOVE   ]TEXT 1- TEXT( ! ;


\ *** LOCK O. 37, EXBLOCK 25

\   LOADTEXT                   17APR20PZ

 : (LOADTEXT  ( -- )
     #CR  ]TEXT 1-  DUP TEXT( !
     DUP 1- )TEXT !  C!
     ]TEXT 2- TEXT[  I/O-STATUS?
          )TEXT !  
     BUS@  C! 
     )TEXT @ DUP 1- C@ #CR =
         DROP  #CR OVER C!
        1+ )TEXT !   1 MEM? DROP ;

 : LOADTEXT  ( -- )
     DEV 2 BUSOPEN   DEV 8 - (DRV !
     FILENAME COUNT BUSTYPE
     " ,S,R"  COUNT BUSTYPE BUSOFF
     PAGE  I/O-STATUS?
         DEV 2 BUSCLOSE
        CHANGED? OFF  .SCREEN
        EXIT 
     DEV 2 BUSIN  (LOADTEXT  BUSOFF
     DEV 2 BUSCLOSE
     CHANGED? OFF  UNFOLD  .SCREEN ;


\ *** LOCK O. 38, EXBLOCK 26

\   SAVESYSTEM                 18APR20PZ

 : (SAVETEXT  ( -- FLAG )
     CR ." WRITING " FILENAME
     COUNT TYPE CR CR
     DEV 15 BUSOUT " S0:." COUNT
     BUSTYPE FILENAME COUNT BUSTYPE
     BUSOFF  DEV 15 BUSOUT " R0:."
     COUNT BUSTYPE FILENAME COUNT 2DUP
     BUSTYPE ASCII =  BUS! BUSTYPE
     BUSOFF   \ DERROR? ?DUP ?EXIT
     DEV 2 BUSOPEN FILENAME COUNT
     BUSTYPE " ,S,W" COUNT BUSTYPE
     BUSOFF  DEV 2 BUSOUT
     TEXT[   )TEXT @  OVER - BUSTYPE
     TEXT( @ ]TEXT 1- OVER - BUSTYPE
     DEV 2 BUSCLOSE  I/O-STATUS? ;

 : SAVETEXT  ( -- )
     PAGE (SAVETEXT
         DERROR? DROP ." WRITE OPERATION FAILED"
        CR KEY DROP
         CHANGED? OFF 
     .SCREEN ;


\ *** LOCK O. 39, EXBLOCK 27

\   DISPLAY                    31AUG94PZ

 : .BOL  ( -- )
     CHAR OFF  VIR-CHAR OFF  1.COLUMN @
         1.COLUMN OFF .SCREEN
         FLIP CSR.COL OFF FLIP
         ;

 : .EOL  ( -- )
     VIR-CHAR OFF
     )TEXT @ 1- CHAR> - DUP >R  CHAR +!
     CSR.COL @ R@ + COL/SCR - DUP 0<
         DROP FLIP R> CSR.COL +! FLIP
         1+ 1.COLUMN +!
        RDROP .SCREEN  ;

 : .CR  ( -- )
     .BOL .DOWN ;


\ *** LOCK O. 40, EXBLOCK 28

\   EXIT                       14SEP94PZ

 : (QUIT-ED  ( -- )  CR
." DO YOU WANT TO QUIT WITHOUT SAVING ?"
     KEY ASCII Y = DUP END? !
     0=  .SCREEN  ;

 : QUIT-ED  ( -- )
     PAGE  CHANGED? @
         (QUIT-ED  END? ON  ;

 : EXIT-ED  ( -- )
     PAGE  CHANGED? @
         (SAVETEXT
            (QUIT-ED EXIT  
     END? ON ;


\ *** LOCK O. 41, EXBLOCK 29

\   INST/DELLINE               15SEP94PZ

 : .KILL-LINE ( -- )
     VIR-CHAR OFF
     TEXT( @ 1+ ]TEXT = ?EXIT
     CHANGED? ON
     LAST-LINE-DOWN
     LINE> @ )TEXT ! LINE-UP
     CSR.ROW> @  (DEL-LINE
     BLANKLINES @ 0=
        LAST-LINE> @ LAST-ROW>
       (.LINE 
     FLIP  .VIR-LEFT ;

 : .INST-LINE ( -- )
     VIR-CHAR OFF   1 MEM? ?EXIT
     CHANGED? ON
     LAST-LINE> @ LINE> @ =
         1 LAST-LINE> +! 
     CHAR @ CHAR OFF (SPLIT-MEM CHAR !
     LINE-DOWN  LAST-LINE-UP
     FLIP  CSR.ROW> @ (INST-LINE
     FLIP  .VIR-LEFT ;


\ *** LOCK O. 42, EXBLOCK 2A

\   FAST UP/DOWN               15SEP94PZ

 : N>PREVLINE  ( LINE +N -- LINE' )
     0  DUP TEXT[ =
          EXIT 
     >PREVLINE  ;

 : N>NEXTLINE  ( LINE +N -- LINE' )
     0  DUP >NEXTLINE  DUP 1+ ]TEXT =
         DROP  EXIT 
     NIP  ;


\ *** LOCK O. 43, EXBLOCK 2B

\   FAST UP/DOWN               15SEP94PZ

 : N-LINE-DOWN  ( +N -- )
     LINE> @ TEXT[ =  DROP EXIT 
     LINE> @ SWAP N>PREVLINE
     DUP LINE> ! >NEXTLINE
     )TEXT @ OVER - >R  DUP )TEXT !
     TEXT( @ R@ - DUP TEXT( !
     R> CMOVE> ;

 : N-LINE-UP  ( +N -- )
     TEXT( @ DUP ROT N>NEXTLINE
     2DUP =  2DROP EXIT 
     OVER - >R  )TEXT @  R@ CMOVE
     R@ )TEXT +!  R> TEXT( +!
     )TEXT @ >PREVLINE LINE> ! ;


\ *** LOCK O. 44, EXBLOCK 2C

\   FAST UP/DOWN               15SEP94PZ

 : .20UP  ( -- )
     1ST-LINE> @ 20 N>PREVLINE
     1ST-LINE> !  20 N-LINE-DOWN
     CHAR OFF  .SCREEN ;

 : .20DOWN  ( -- )
     20 N-LINE-UP
     1ST-LINE> @ 20 N>NEXTLINE
     1ST-LINE> !
     CHAR OFF  .SCREEN ;
