\ *** LOCK O. 112, EXBLOCK 70

\ FILE-I/O                     20SEP94PZ

\ *** LOCK O. 113, EXBLOCK 71

\   FILE-I/O                   21SEP94PZ

 : FHANDLE  CREATE 6 ALLOT ;

 : SET-FHANDLE  ( DEV 2ND HANDLE -- )
     DUP OFF  2+ 2! ;

 VARIABLE >HANDLE
 : HANDLE  >HANDLE @ ;
 -1 CONSTANT #EOF

 : FEOF?  ( HANDLE -- FLAG ) @ ;


\  VARIABLE FDELAY  10 FDELAY !

\  : FWAIT  ( -- )
\      FDELAY @ 0 ?
\      $00A1 @  DUP $00A1 @ - 
\      DROP  ;


\ *** LOCK O. 114, EXBLOCK 72

\   FILE-I/O                   21SEP94PZ

 : FOPEN  ( MODE TYPE NAME HANDLE -- )
     DUP OFF
     2+ 2@ BUSOPEN  COUNT BUSTYPE
     ASCII , BUS!  BUS!
     ASCII , BUS!  BUS!  BUSOFF ;

 : FCLOSE  ( HANDLE -- )
     2+ 2@ BUSCLOSE ;

 : FSETIN  ( HANDLE -- )
     DUP >HANDLE ! 2+ 2@ BUSIN ;

 : FSETOUT  ( HANDLE -- )
     DUP >HANDLE ! 2+ 2@ BUSOUT ;

 ' BUSOFF  FUNSET  ( -- )


\ *** LOCK O. 115, EXBLOCK 73

\   FILE-I/O                   13SEP94PZ

 : FGETC  ( -- C )
     HANDLE @  #EOF  BUS@
            I/O-STATUS? HANDLE !  ;

 : FGETS  ( ADR N -- N' )
     HANDLE @  2DROP 0 EXIT 
     0 -ROT BOUNDS  ? BUS@  C! 1+
     I/O-STATUS?     
     I/O-STATUS? HANDLE ! ;

 : FGET2DELIM ( ADR N DELIM -- N' F )
     HANDLE @  2DROP DROP 0. EXIT 
     -ROT 0 -ROT BOUNDS
      1-  OVER BUS@ UNDER =
         DROP NEGATE  
      C!   I/O-STATUS?
         NEGATE    
     DUP 0<
          1- OVER BUS@ - 
        I/O-STATUS?  NEGATE NIP -1
         NIP 0 
     I/O-STATUS? HANDLE ! ;


\ *** LOCK O. 116, EXBLOCK 74

\   FILE-I/O                   11SEP94PZ

 : FSKIP  ( N -- )
     HANDLE @  DROP EXIT 
     0 ? BUS@ DROP I/O-STATUS?
             
     I/O-STATUS? HANDLE ! ;


 ' BUS!  FPUTC  ( C -- )

 ' BUSTYPE  FPUTS  ( ADR N -- )

 : HEX!  ( N -- )
     "  0X" COUNT FPUTS
     BASE PUSH HEX 0 <# #S #> FPUTS ;

 : CR!  ( -- )  $0D FPUTC ;

 : STR! ( STRING -- ) COUNT FPUTS ;
