\ *** LOCK O. 78, EXBLOCK 4E

\ FILEMAN: LOADSCREEN          20SEP94PZ

\ TERMINOLOGY / INTERFACE:

\ SOURCE-FILE
\ CODE-FILE       CODE-NAME
\ STATIC-FILE     STATIC-NAME

\ /FILENAME
\ DEV             DEV#

\ CLOSE-FILES     SCRATCHFILES
\ OPEN-OUTFILES   CLOSE-OUTFILES
\ REOPEN-OUTFILES

\ INIT-FILES


\ *** LOCK O. 79, EXBLOCK 4F

\   FILEMAN:                   20SEP94PZ

 FHANDLE SOURCE-FILE
 FHANDLE CODE-FILE
 FHANDLE STATIC-FILE
 FHANDLE EXE-FILE

 17 CONSTANT /FILENAME
 CREATE EXE-NAME   /FILENAME ALLOT

 CREATE CODE-NAME    ," %%CODE"
 CREATE STATIC-NAME  ," %%INIT"

 CREATE DEV#  8 C,
 : DEV   ( -- DEV )  DEV# C@ ;
 CREATE AUX#  8 C,
 : AUX   ( -- AUX )  AUX# C@ ;

 : INIT-FILES
     DEV 2 SOURCE-FILE  SET-FHANDLE
     AUX 3 CODE-FILE    SET-FHANDLE
     AUX 4 STATIC-FILE  SET-FHANDLE
     DEV 5 EXE-FILE     SET-FHANDLE ;

    INIT: INIT-FILES


\ *** LOCK O. 80, EXBLOCK 50

\   FILEMAN:                   11SEP94PZ

 : LOADADR!  ( HANDLE -- )
     FSETOUT 0 FPUTC 64 FPUTC FUNSET ;

 : OPEN-OUTFILES  ( -- )
     ASCII W ASCII P CODE-NAME
     CODE-FILE FOPEN
     CODE-FILE LOADADR!
     ASCII W ASCII P STATIC-NAME
     STATIC-FILE FOPEN
     STATIC-FILE LOADADR! ;

 : CLOSE-OUTFILES  ( -- )
     CODE-FILE   FCLOSE
     STATIC-FILE FCLOSE ;

 : REOPEN-OUTFILES  ( -- )
     CLOSE-OUTFILES
     ASCII A ASCII P CODE-NAME
     CODE-FILE FOPEN
     ASCII A ASCII P STATIC-NAME
     STATIC-FILE FOPEN ;


\ *** LOCK O. 81, EXBLOCK 51

\   FILEMAN:                   13APR20PZ

MAKE CLOSE-FILES  ( -- )
      SOURCE-FILE  FCLOSE
      EXE-FILE     FCLOSE
      CLOSE-OUTFILES ;

MAKE SCRATCHFILES ( -- )
  ." SCRATCHING TEMPORARY FILES" CR
  DEV 15 BUSOUT
  " S0:%%CODE" COUNT BUSTYPE BUSOFF
  DEV 15 BUSOUT
  " S0:%%INIT" COUNT BUSTYPE BUSOFF ;
