\ *** LOCK O. 36, EXBLOCK 24

\ SCANNER: LOADSCREEN          20SEP94PZ

\ TERMINOLOGY / INTERFACE:
\   NEXTWORD   BACKWORD
\   MARK       ADVANCED?
\   WORD.
\   START$     BUILD$      END$     DO$
\   ALLE TOKENS
\   ( INIT-SCANNER )

\ *** LOCK O. 37, EXBLOCK 25

\   SCANNER:                   26FEB91PZ

\PROF PROFILER-BUCKET [SCANNER-ALPHANUM]

 : SKIPBLANKS  ( -- )
      CHAR> BL = 
     +CHAR  ;

\PROF [SCANNER-ALPHANUM] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-KEYWORD]

 0 CONSTANT #CHAR#
 1 CONSTANT #ID#
 2 CONSTANT #NUMBER#
 3 CONSTANT #KEYWORD#
 4 CONSTANT #OPER#
 5 CONSTANT #STRING#
 : #EOF#  -1 DUP ;


\ *** LOCK O. 38, EXBLOCK 26

\   SCANNER:                   12JAN91PZ

 19 STRING-TAB KEYWORDS

 X <DO>       X" DO"
 X <IF>       X" IF"
 X <FOR>      X" FOR"
 X <INT>      X" INT"
 X <AUTO>     X" AUTO"
 X <CASE>     X" CASE"
 X <CHAR>     X" CHAR"
 X <ELSE>     X" ELSE"
 X <GOTO>     X" GOTO"
 X <BREAK>    X" BREAK"
 X <WHILE>    X" WHILE"
 X <EXTERN>   X" EXTERN"
 X <RETURN>   X" RETURN"
 X <STATIC>   X" STATIC"
 X <SWITCH>   X" SWITCH"
 X <DEFAULT>  X" DEFAULT"
 X <CONT>     X" CONTINUE"
 X <REGISTER> X" REGISTER"
 X <FASTCALL> X" _FASTCALL"

END-TAB

 KEYWORDS 2 9 LENGTH-INDEX KEYWORDS-INDEX
  <DO> IDX,
  <FOR> IDX,
  <AUTO> IDX,
  <BREAK> IDX,
  <EXTERN> IDX,
  <DEFAULT> IDX,
  <CONT> IDX,
  <FASTCALL> IDX,
END-INDEX

\ *** LOCK O. 39, EXBLOCK 27

\   SCANNER:                   18APR94PZ

 : KEYWORD?  ( ADR -- FALSE )
               ( ADR -- TOKEN TRUE )
     KEYWORDS-INDEX  FIND-VIA-INDEX ;


\ *** LOCK O. 40, EXBLOCK 28

\   SCANNER:                   18APR94PZ

\PROF [SCANNER-KEYWORD] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-IDENTIFIER]

 CREATE ID-BUF  /ID 1+ ALLOT

 : GET-ID ( -- )
     ID-BUF 1+ /ID BOUNDS
      CHAR>  C! +CHAR CHAR>
     ALPHANUM? 0=
          ID-BUF - ID-BUF C!
         EXIT 
      /ID ID-BUF C!
      +CHAR CHAR>
     ALPHANUM? 0=  ;

 : ID ( -- TOKENVALUE TOKEN )
     GET-ID  ID-BUF KEYWORD?
         #KEYWORD#
         ID-BUF #ID#  ;


\ *** LOCK O. 41, EXBLOCK 29

\   SCANNER:                   08OCT90PZ

\PROF [SCANNER-IDENTIFIER] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-OPERATOR]

HERE ," +++---**///%%&&&^^!!==<<<<>>>>" 1+  CONSTANT OPER-1ST-CH
HERE ," += -= = =* = =& = = = = <<= >>=  " 1+  CONSTANT OPER-2ND-CH
HERE ,"                          =   =    " 1+  CONSTANT OPER-3RD-CH

ENUM
  ON
  Y <++>    Y <+=>    Y <+>
  Y <-->    Y <-=>    Y <->
  Y <*=>    Y <*>
  Y </=>    Y <COMMENT>         Y </>
  Y <%=>    Y <%>
  Y <AND=>  Y <L-AND> Y <AND>
  Y <OR=>   Y <L-OR>  Y <OR>
  Y <XOR=>  Y <XOR>
  Y <!=>    Y <!>
  Y <==>    Y <=>
  Y <<<=>   Y <<<>    Y <<=>    Y <<>
  Y <>>=>   Y <>>>    Y <>=>    Y <>>
  Y <INV>
  OFF
END-ENUM


\ *** LOCK O. 42, EXBLOCK 2A

\   SCANNER:                   08OCT90PZ

 CREATE $2?-TAB
  $FF    C,  <!=>   C,  $FF    C,  $FF    C,
  $FF    C,  <%=>   C,  <AND=> C,  $FF    C,
  $FF    C,  $FF    C,  <*=>   C,  <++>   C,
  $FF    C,  <-->   C,  $FF    C,  </=>   C,

 : $2?-OPER?  ( C -- TOKENVALUE T / C -- F )
     $0F AND $2?-TAB + C@ DUP $FF =  DROP FALSE  +CHAR TRUE  ;

 CREATE $?C-TAB
  <<<=>  C,  <==>   C,  <>>=>  C,  $FF    C,
  $FF    C,  $FF    C,  <XOR=> C,  $FF    C,
  <OR=>  C,  $FF    C,  <INV>  C,  $FF    C,

 : $?C-OPER?  ( C -- TOKENVALUE T / C -- F )
     DUP 3 AND SWAP $E0 AND $20 -
     DUP $20 >  $A0 -  DROP FALSE EXIT  $40  2/ 2/ 2/ +
     $?C-TAB + C@ DUP $FF =  DROP FALSE  +CHAR TRUE  ;

 : OPERATOR?  ( C -- TOKENVALUE T / C -- F )
     DUP $F0 AND $20 =  $2?-OPER? EXIT 
     DUP $1F AND $1B >  $?C-OPER? EXIT 
     DROP FALSE ;

 : C@-BL=-IF-#OPER#-EXIT
       ( TOKENVALUE PTR> -- TOKENVALUE CHR / -- TOKENVALUE #OPER# )
     C@ DUP BL =  DROP #OPER# RDROP EXIT  ;

 : LIMIT-OPER-LOOP  ( N -- N )
     DUP <INV> > *COMPILER* ?FATAL ;

 : OPERATOR ( TOKENVALUE1 -- TOKENVALUE2 #OP# )
      DUP OPER-2ND-CH + C@-BL=-IF-#OPER#-EXIT
     CHAR> -  1+ LIMIT-OPER-LOOP  +CHAR
      DUP OPER-3RD-CH + C@-BL=-IF-#OPER#-EXIT
     CHAR> -  1+ LIMIT-OPER-LOOP  +CHAR #OPER# ;

\PROF [SCANNER-OPERATOR] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-NUMBER]

\ *** LOCK O. 43, EXBLOCK 2B

\   SCANNER:                   13FEB91PZ

 : OCTNUM ( -- N )
     0  CHAR> ASCII 0 -
     DUP 8 U< 
     SWAP 8 * +  +CHAR  DROP ;

 : DEZNUM ( -- N )
     0  CHAR> ASCII 0 -
     DUP 10 U< 
     SWAP 10 * +  +CHAR  DROP ;

 : HEXDIGIT ( C -- N/-1 )
     CAPITAL  ASCII 0 -
     DUP 10 U< ?EXIT
     [ ASCII  ASCII 0 - ] LITERAL -
     DUP 6 U<  10 +
               DROP -1  ;

 : HEXNUM ( -- N )
     0  CHAR> HEXDIGIT
     DUP 16 U< 
     SWAP 16 * +  +CHAR  DROP ;


\ *** LOCK O. 44, EXBLOCK 2C

\   SCANNER:                   03OCT90PZ

 : NUMBER ( -- N #NUMBER# )
     CHAR> ASCII 0 =
         +CHAR CHAR> CAPITAL
        ASCII  =  +CHAR HEXNUM
                   OCTNUM 
         DEZNUM  #NUMBER# ;

\PROF [SCANNER-NUMBER] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-CHAR/STRING]

 CREATE CHARLIST ," ()[],;:?"

 : LEGALCHAR? ( C -- C TRUE  )
               ( C --   FALSE )
     CHARLIST COUNT BOUNDS
      DUP  C@ =
          TRUE EXIT 
      DROP *LEX* ERROR FALSE ;


\ *** LOCK O. 45, EXBLOCK 2D

\   SCANNER:                   02MAR94PZ

 CREATE \LIST ," BTNFR0\' "
  ASCII " HERE 1- C!
  8 C, 9 C, 13 C, 12 C, 13 C, 0 C,
  ASCII \ C,  ASCII ' C,  ASCII " C,

 256 CONSTANT NONE

 : \CHAR ( -- C )
     CHAR> 0=  NEXTLINE NONE EXIT 
     \LIST COUNT BOUNDS
       C@ CHAR> =
         +CHAR  \LIST C@ + C@
         EXIT 
     
     CHAR> ASCII 1 ASCII 8 UWITHIN
         0  3 0  CHAR> ASCII 0 -
        7 OVER U<  DROP  
        SWAP 8 * +  +CHAR   255 AND
         NONE  ;


\ *** LOCK O. 46, EXBLOCK 2E

\   SCANNER:                   03OCT90PZ

 512 CONSTANT ERR

 : CHAR-CONST ( -- C #NUMBER# )
      CHAR> 0 CASE?
         *EOL* ERROR ERR
         +CHAR ASCII ' CASE?
            *LEX* ERROR ERR
            ASCII \ CASE?
               \CHAR   
     DUP NONE - 
     DUP ERR -
        CHAR> ASCII ' =
          +CHAR  *LEX* ERROR 
       
     255 AND #NUMBER# ;


\ *** LOCK O. 47, EXBLOCK 2F

\   SCANNER:                   21FEB91PZ

 VARIABLE DO$
 : $: REATE C,
       OES> C@ DO$ @ + PERFORM ;

 0 $: $[  ( -- SYS )
 2 $: $,  ( C -- )
 4 $: ]$  ( SYS -- DESC )

 VARIABLE $PENDING

 : DO$:  REATE:
    OES> ( PFA -- DESC )  DO$ !
     $PENDING @ 0= *COMPILER* ?FATAL
     $[  CHAR> 0= *EOL* ?ERROR
     CHAR>  CHAR> ASCII " - 
     CHAR> +CHAR ASCII \ CASE?
         \CHAR 
     DUP NONE =
         DROP  255 AND $, 
     
     CHAR>  +CHAR 
     0 $,  ]$  $PENDING OFF ;


\ *** LOCK O. 48, EXBLOCK 30

\   SCANNER:                   14SEP94PZ

 : STRING ( -- ??? #STRING# )
     $PENDING ON  0 #STRING# ;

\PROF [SCANNER-CHAR/STRING] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-(NEXTWORD]

 : (NEXTWORD ( -- TOKENVALUE TOKEN )
     $PENDING @  *COMPILER* ?FATAL
     
       SKIPBLANKS  CHAR> 0=
      EOF @ 0= AND  NEXTLINE 
     EOF @ #EOF =  #EOF#  EXIT 
     CHAR> ALPHA?  ID EXIT 
     CHAR> NUM?    NUMBER EXIT 
     CHAR> OPERATOR?
                   OPERATOR EXIT 
     CHAR> ASCII " =
         +CHAR STRING EXIT 
     CHAR> ASCII ' =
         +CHAR CHAR-CONST EXIT 
     CHAR> +CHAR LEGALCHAR? 
     #CHAR# ;


\ *** LOCK O. 49, EXBLOCK 31

\   SCANNER:                   09OCT90PZ

\PROF [SCANNER-(NEXTWORD] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-COMMENT]

 : IS-COMMENT? ( W T -- W T FLAG )
     2DUP <COMMENT> #OPER# DNEGATE D+
     OR 0= ;

 ' COMMENT-STATE  ST

 : SKIP-COMMENT ( -- )
     LINE @ COMMENT-LINE !
     2 ST !
      CHAR> +CHAR ASCII * CASE?
         1 ST !
         ASCII / CASE?
            ST @ 1 =  ST OFF
                        2 ST ! 
            2 ST ! 0=
               NEXTLINE   
     ST @ 0=  ;


\ *** LOCK O. 50, EXBLOCK 32

\   SCANNER:                   11MAR91PZ

\PROF [SCANNER-COMMENT] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-NEXTWORD]

\PROF PROFILER-BUCKET [SCANNER-NEXTWORD-VARS]

 CREATE WORD'  4 ALLOT
 VARIABLE WORD#

\PROF [SCANNER-NEXTWORD-VARS] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-FETCHWORD]

 : FETCHWORD ( -- TOKENVALUE TOKEN )
      (NEXTWORD IS-COMMENT? 
     2DROP SKIP-COMMENT  \ ."  FETCHWORD: " 2DUP U. U.
     WORD' 2! ;

 : ACCEPT ( -- )
     1 WORD# +!  FETCHWORD ;

\PROF [SCANNER-FETCHWORD] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-THISWORD]

 : THISWORD ( -- TOKENVALUE TOKEN )  WORD' 2@ ;

\PROF [SCANNER-THISWORD] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-NEXTWORD-MARK]

 : MARK ( -- WORD# )  WORD# @ ;

\PROF [SCANNER-NEXTWORD-MARK] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-NEXTWORD-ADVANCED?]

 : ADVANCED? ( WORD# -- FLAG )
     WORD# @ = 0= ;

\PROF [SCANNER-NEXTWORD-ADVANCED?] END-BUCKET

\PROF [SCANNER-NEXTWORD] END-BUCKET
\PROF PROFILER-BUCKET [SCANNER-REST]

 : INIT-SCANNER
   $PENDING OFF  WORD# OFF ;
    INIT: INIT-SCANNER


\ *** LOCK O. 51, EXBLOCK 33

\   SCANNER: WORD.             03OCT90PZ

 : KEYWORD. ( TOKENVALUE )
     KEYWORDS SWAP STRING[]
     >STRING COUNT TYPE ;

 : EMIT' ( CHAR ) DUP BL -
           EMIT  DROP  ;

 : OPER. ( TOKENVALUE )
     DUP OPER-1ST-CH + C@ EMIT
     DUP OPER-2ND-CH + C@ EMIT'
         OPER-3RD-CH + C@ EMIT' ;

 : WORD.  ( TOKENVALUE TOKEN )
  #KEYWORD# CASE?  KEYWORD. EXIT 
  #OPER#    CASE?  OPER.    EXIT 
  #NUMBER#  CASE?  .        EXIT 
  #CHAR#    CASE?  EMIT     EXIT 
  #ID#      CASE?  COUNT TYPE
                              EXIT 
  #STRING#  CASE?  ." STRING @ " U.
                              EXIT 
  ." TOKEN/VAL:" . . ;

\PROF [SCANNER-REST] END-BUCKET
