
\ HIS IS THE REFERENCE IMPLEMENTATION OF TMPHEAP WHICH ALLOCATES
\ THE TMPHEAP ON THE REGULAR HEAP AND MOVES DEFINITONS PREFIXED
\ WITH  OR WITHIN A ON TO OFF RANGE ONTO THE TMPHEAP.
\ TMP-CLEAR WILL REMOVE ALL WORDS ON THE TMPHEAP, WHERAS REGULAR CLEAR
\ WILL REMOVE ALL WORDS ON TMPHEAP AND HEAP TOGETHER.

\ EFORE THE FIRST USE OF , THE TMPHEAP SIZE IN BYTES MUST BE
\ SET WITH MK-TMP-HEAP ( SIZE -- )

 SER TMPHEAP[
 SER TMPHEAP>
 SER ]TMPHEAP

 : RESET-TMP-HEAP  ( -- )
  UP@ DUP ]TMPHEAP !  DUP TMPHEAP> !  TMPHEAP[ ! ;

RESET-TMP-HEAP
' RESET-TMP-HEAP IS CUSTOM-REMOVE

 : MK-TMP-HEAP  ( SIZE -- )
    HEAP DUP ]TMPHEAP ! TMPHEAP> !  HALLOT  HEAP TMPHEAP[ ! ;

 : TMP-HALLOT  ( SIZE -- ADDR )
    TMPHEAP> @ SWAP -
    DUP TMPHEAP[ @ U< ABORT" TMP HEAP OVERFLOW"
    DUP TMPHEAP> ! ;

 : TMP-HEAPMOVE   ( FROM FROM SIZE -- FROM OFFSET )
   DUP TMP-HALLOT  SWAP CMOVE
   TMPHEAP> @ OVER - ;

 : TMP-HEAPMOVE1X   ( FROM SIZE -- FROM OFFSET )
   TMP-HEAPMOVE  ?HEADMOVE-XT OFF ;

 :      ['] TMP-HEAPMOVE1X  ?HEADMOVE-XT ! ;
 : ON   ['] TMP-HEAPMOVE    ?HEADMOVE-XT ! ;
 : OFF  ?HEADMOVE-XT OFF ;


 : REMOVE-TMP-WORDS-IN-VOC  ( VOC -- )
   DUP @ ?DUP   ( THREAD NEXT-IN-THREAD )
    DUP TMPHEAP[ @ ]TMPHEAP @ UWITHIN   ( THREAD NEXT-IN-THREAD )
      @ ?DUP  ( THREAD NEXT-NEXT-IN-THREAD ) OVER ! 
       ( THREAD ) OFF EXIT 
     ( THREAD NEXT-IN-THREAD ) NIP
    
   DROP ;

 : REMOVE-TMP-WORDS  ( -- )
  VOC-LINK    @ ?DUP
    DUP 4 - REMOVE-TMP-WORDS-IN-VOC   ;

 : TMP-CLEAR  ( -- )
  REMOVE-TMP-WORDS
  \ NCOMMENT THE FOLLOWING LINE TO HELP DETERMINE THE IDEAL TMPHEAP
  \ SIZE FOR YOUR PROJECT.
  \ TMPHEAP> @ TMPHEAP[ @ - CR U. ." SPARE TMPHEAP BYTES"
  ]TMPHEAP @ TMPHEAP> !  LAST OFF ;
