\ *** LOCK O. 47, EXBLOCK 2F

\ TRACER: LOADSCREEN          CAS16AUG06

NLYFORTH

\NEEDS ODE INCLUDE TRNS6502ASM.FTH

\NEEDS OOLS   OCABULARY OOLS

OOLS ALSO DEFINITIONS

\ HIS NICE ORTH RACER HAS BEEN
\ DEVELOPED BY . ENNEMANN AND CO
\ FOR TARI .  OGT HAS PORTED IT
\ BACK TO THE VOLKSORTH 6502 -16 AND
\ -64


\ *** LOCK O. 48, EXBLOCK 30

\ TRACER: WCMP VARIABLES      CLV04AUG87

SSEMBLER ALSO DEFINITIONS

: WCMP ( ADR1 ADR2--) \ SSEMBLER-ACRO
 OVER LDA DUP CMP SWAP  \ COMPARES WORD
 1+   LDA 1+  SBC ;


NLY ORTH ALSO OOLS ALSO DEFINITIONS

 ARIABLE (
 ARIABLE <IP       ARIABLE IP>
 ARIABLE NEST?     ARIABLE TRAP?
 ARIABLE LAST'     ARIABLE #SPACES


\ *** LOCK O. 49, EXBLOCK 31

\ TRACER:CPUSH ONELINE        CAS16AUG06

 REATE CPULL    0  ]
 RP@ COUNT 2DUP + RP! R> SWAP CMOVE ;

: CPUSH  ( ADDR LEN -)
 R> -ROT   OVER  >R
 RP@ OVER 1+ - DUP RP!  PLACE
 CPULL >R  >R ;

 : ONELINE  &82 ALLOT KEYBOARD DISPLAY
 .STATUS  SPACE  QUERY  INTERPRET
 -&82 ALLOT  RDROP
 ( DELETE QUIT FROM TNEXT )  ;

: RANGE ( ADR--) \ GETS <IP IP>
 IP> OFF  DUP <IP !
  1+ DUP @
   [ ORTH ] ['] UNNEST = 
 3+ IP> ! ;


\ *** LOCK O. 50, EXBLOCK 32

\ TRACER:STEP TNEXT           CLV04AUG87

 ODE STEP
 $FF # LDA TRAP? STA TRAP? 1+ STA
            ) LDA   STA
  ) LDA   1+ STA   2INC
 ( LDA   STA   ( 1+ LDA    1+ STA
ABEL 1-   1- JMP  END-CODE

 REATE: NEXTSTEP STEP ;

ABEL  TNEXT  2INC
 TRAP? LDA  1- BEQ
 NEST? LDA 0=  \ LOW(!)YTE TEST
 ?[  <IP WCMP 1- BCC
     IP> WCMP 1- BCS
 ][ NEST? STX  \ LOW(!)YTE CLEAR
 ]?
  TRAP? DUP STX 1+ STX \ DISABLE TRACER
   LDA  ( STA     1+ LDA   ( 1+ STA


\ *** LOCK O. 51, EXBLOCK 33

\ TRACER:..TNEXT              CLV12OCT87

 ;C: NEST? @
  NEST? OFF R> IP> PUSH <IP PUSH
    DUP 2- RANGE
    #SPACES PUSH 1 #SPACES +! >R 
 R@  NEXTSTEP >R
 INPUT PUSH    OUTPUT PUSH
 2- DUP LAST' !
 CR #SPACES @ SPACES
 DUP 4 U.R @ DUP 5 U.R SPACE
 >NAME .NAME  $10 COL - 0 MAX SPACES .S
 STATE PUSH  BLK PUSH  >IN PUSH
 [ ' 'QUIT      >BODY ] ITERAL  PUSH
 [ ' >INTERPRET >BODY ] ITERAL  PUSH
 #TIB PUSH  TIB #TIB @ CPUSH  R0 PUSH
 RP@ R0 !
 ['] ONELINE S 'QUIT  QUIT ;


\ *** LOCK O. 52, EXBLOCK 34

\ TRACER:DO-TRACE TRACEABLE   CAS16AUG06

 ODE DO-TRACE \ INSTALLS 
 TNEXT 0 $100 M/MOD
     # LDA  EXT $C + STA
     # LDA  EXT $B + STA
 $4 # LDA  EXT $A + STA  EXT JMP
END-CODE

 : TRACEABLE ( CFA--< ) RECURSIVE
 DUP @
 ['] :    @ CASE?  >BODY     EXIT 
 ['] KEY  @ CASE?  >BODY C@ NPUT  @ +
                   @ TRACEABLE EXIT 
 ['] TYPE @ CASE?  >BODY C@ UTPUT @ +
                   @ TRACEABLE EXIT 
 ['] R/W  @ CASE?  >BODY
                   @ TRACEABLE EXIT 
 @  [ ' ORTH @ @ ] ITERAL =
                   @ 3 + EXIT 
 \ FOR DEFINING WORDS WITH >
 >NAME .NAME ." CAN'T BE GED"
 QUIT ;


\ *** LOCK O. 53, EXBLOCK 35

\ TRACER:SER-ORDS           CAS16AUG06

: NEST   \ TRACE INTO CURRENT WORD
 LAST' @ @ TRACEABLE DROP NEST? ON ;

: UNNEST \ PROCEEDS AT CALLING WORD
 <IP ON IP> OFF ; \ CLEARS TRAP RANGE

: ENDLOOP LAST' @ 4 + <IP ! ;
\ NO TRACE OF NEXT WORD TO SKIP ..

' END-TRACE LIAS UNBUG \ CONT. EXECUT.

: (DEBUG  ( CFA-- )
 TRACEABLE RANGE
 NEST? OFF TRAP? ON #SPACES OFF
 OOLS DO-TRACE ;

ORTH DEFINITIONS

: DEBUG  ' (DEBUG ; \ WORD FOLLOWS

: TRACE'            \ WORD FOLLOWS
 ' DUP (DEBUG EXECUTE END-TRACE ;


\ *** LOCK O. 54, EXBLOCK 36

\ TOOLS FOR DECOMPILING,      CLV12OCT87

( INTERACTIVE USE                      )

NLYFORTH OOLS ALSO DEFINITIONS

 : ?:  ?CR DUP 4 U.R ." :"  ;
 : @?  DUP @ 6 U.R ;
 : C?  DUP C@ 3 .R ;
 : BL  $24 COL - 0 MAX SPACES ;

: S  ( ADR - ADR+)
 ( PRINT LITERAL STRING)
 ?:  SPACE C? 4 SPACES DUP COUNT TYPE
 DUP C@ + 1+ BL  ;  ( COUNT + RE)

: N  ( ADR - ADR+2)
 ( PRINT NAME OF NEXT WORD BY ITS CFA)
 ?: @? 2 SPACES
 DUP @ >NAME .NAME 2+ BL ;

: K  ( ADR - ADR+2)
 ( PRINT LITERAL VALUE)
 ?: @? 2+ BL ;


\ *** LOCK O. 55, EXBLOCK 37

( TOOLS FOR DECOMPILING, INTERACTIVE   )

: D  ( ADR N - ADR+N) ( DUMP N BYTES)
 2DUP SWAP ?: 3 SPACES  SWAP 0
   C? 1+ 
 4 SPACES -ROT TYPE BL ;

: C  ( ADR - ADR+1)
 ( PRINT BYTE AS UNSIGNED VALUE)
 1 D ;

: B  ( ADR - ADR+2)
 ( PRINT BRANCH TARGET LOCATION )
 ?: @? DUP @  OVER + 6 U.R 2+ BL  ;

( USED FOR : )
( AME TRING ITERAL UMP LIT RANCH )
( -    -      -       -    -    -      )


NLYFORTH
