
\ HIS IS A CUSTOM IMPLEMENTATION OF TMPHEAP FOR THE 16 WHICH
\ ALLOCATES THE TMPHEAP IN A  BANK AND MOVES DEFINITONS PREFIXED
\ WITH  OR WITHIN A ON TO OFF RANGE THERE.
\ TMP-CLEAR WILL REMOVE ALL WORDS ON THE TMPHEAP, WHERAS REGULAR CLEAR
\ WILL REMOVE ALL WORDS ON TMPHEAP AND HEAP TOGETHER.

\ THER THAN THE REFERENCE TMPHEAP LIVING ON THE REGULAR HEAP, THIS
\ CUSTOM TMPHEAP NEEDS NO INITIALIZATION AS ITS POSITION AND
\ SIZE (8K) IS FIXED.

 SER TMPHEAP[
 SER TMPHEAP>
 SER ]TMPHEAP

 1 $0000 C!  $A000 TMPHEAP[ !  $C000 DUP ]TMPHEAP ! TMPHEAP> !

 : TMP-HALLOT  ( SIZE -- ADDR )
    TMPHEAP> @ SWAP -
    DUP TMPHEAP[ @ U< ABORT" TMP HEAP OVERFLOW"
    DUP TMPHEAP> ! ;

 : TMP-HEAPMOVE   ( FROM FROM SIZE -- FROM OFFSET )
   DUP TMP-HALLOT  SWAP CMOVE
   TMPHEAP> @ OVER - ;

 : TMP-HEAPMOVE1X   ( FROM SIZE -- FROM OFFSET )
   TMP-HEAPMOVE  ?HEADMOVE-XT OFF ;

 :      ['] TMP-HEAPMOVE1X  ?HEADMOVE-XT ! ;
 : ON   ['] TMP-HEAPMOVE    ?HEADMOVE-XT ! ;
 : OFF  ?HEADMOVE-XT OFF ;


 : REMOVE-TMP-WORDS-IN-VOC  ( VOC -- )
   DUP @ ?DUP   ( THREAD NEXT-IN-THREAD )
    DUP TMPHEAP[ @ ]TMPHEAP @ UWITHIN   ( THREAD NEXT-IN-THREAD )
      @ ?DUP  ( THREAD NEXT-NEXT-IN-THREAD ) OVER ! 
       ( THREAD ) OFF EXIT 
     ( THREAD NEXT-IN-THREAD ) NIP
    
   DROP ;

 : REMOVE-TMP-WORDS ( -- )
  VOC-LINK    @ ?DUP
    DUP 4 - REMOVE-TMP-WORDS-IN-VOC   ;

 : TMP-CLEAR  ( -- )
  REMOVE-TMP-WORDS
  \ NCOMMENT THE FOLLOWING LINE TO HELP DETERMINE THE IDEAL TMPHEAP
  \ SIZE FOR YOUR PROJECT.
  \ TMPHEAP> @ TMPHEAP[ @ - CR U. ." TMPHEAP SPARE"
  ]TMPHEAP @ TMPHEAP> !  LAST OFF ;

' TMP-CLEAR IS CUSTOM-REMOVE
